<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use App\User;
use App\MarketingLoginImage;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;
use App\Mail\VerificationMail;
use App\Mail\ResetMail;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

class AuthController extends Controller
{
    public function login() {
        $loginImage = MarketingLoginImage::find(1);
        return view('authentication.login',compact('loginImage'));
    }

    public function login_submit(Request $request) {
        $validator = Validator::make($request->all(), [
            'email' => 'required|email',
            'password' => 'required',
        ]);

        if ($validator->fails()) {
            return redirect()->back()
                ->withErrors($validator)
                ->withInput();
        }

        $email = $request->email;
        $password = $request->password;
        $check = $request->remember_me;

        $user = User::where('email',$email)->first();
        // if(($user!=null && $user->count() > 0) && Hash::check($password, $user->password)){
            if(($user!=null && $user->count() > 0) && auth()->attempt(['email' => $user->email, 'password' => request()->password])){
            if($user->agreed == 2){
                if($user->role == 'subadmin') return redirect()->back()->with('error','This User has been blocked');
            }
            if($user->agreed == 1){
                $request->session()->put('uv_user_id', $user->id);
                if($user->role == 'superadmin') return redirect('dashboard');
                if($user->role == 'admin') return redirect()->route('software.index');
                if($user->role == 'subadmin') return redirect()->route('software.index');
            }
            else{
            $code = mt_rand(100000, 999999);
            $request->session()->put('code', $code);
            Mail::to($user->email)->send(new VerificationMail());
            $request->session()->put('uv_user_id', $user->id);
            return redirect("verification");
            }
        }else{
            $valid['password'] = "Wrong password!";
            return redirect()->back()
                ->withErrors($valid)
                ->withInput();
        }

        // if($check == 'on'){

        // }

    }

    public function verification(){
        // dd(session()->all());
        return view('authentication.verification');
    }
    public function verify(Request $request){
        $validator = Validator::make($request->all(), [
            'code' => 'required |max:6',
        ]);

        if ($validator->fails()) {
            return redirect()->back()
                ->withErrors($validator)
                ->withInput();
        }
        $code = session('code');
        $input_code = $request->code;
        if($code == $input_code){
            $user_id = session('uv_user_id');
            $user = User::where('id',$user_id)->first();
            if($user->software == "super admin"){
                $request->session()->put('user_id', $user_id);
                return redirect('dashboard');
            }
            if($user->role == 'superadmin') return redirect('dashboard');
            if($user->role == 'admin') return redirect()->route('crusher.index');
            if($user->role == 'subadmin') return redirect()->route('crusher.index');
        }else{
            $valid['in_code'] = "Invalid OTP";
            return redirect()->back()
                ->withErrors($valid)
                ->withInput();
        }
    }
    public function forget_password() {
        return view('authentication.forgetpassword');
    }
    public function reset(Request $request) {

        $validator = Validator::make($request->all(), [
            'email' => 'required|email',
        ]);

        if ($validator->fails()) {
            return redirect()->back()
                ->withErrors($validator)
                ->withInput();
        }

        $email = $request->email;
        $user = User::where('email',$email)->first();
        if($user == NULL){
            $valid['email'] = "Email doesn't exists!";
            return redirect()->back()
                ->withErrors($valid)
                ->withInput();
        }
        $token = Str::random(64);
        $request->session()->put('uv_user_id', $user->id);
        $request->session()->put('token', $token);
        Mail::to($user->email)->send(new ResetMail());
        return redirect('login');
    }
    public function reset_pass(Request $request, $token) {
        $session_token = session('token');
        if($token != $session_token){
            return view('super_admin.404');
        }
        return view('authentication.reset');
    }

    public function reset_password(Request $request) {
        $password = $request->password;
        $confirm_password = $request->confirm_password;
        if($password != $confirm_password){
            $valid['confirm_password'] = "Password didn't matched!";
            return redirect()->back()
                ->withErrors($valid)
                ->withInput();
        }
        $hashed_password = Hash::make($confirm_password);
        $updateData['password'] = $hashed_password;
        $user_id = session('uv_user_id');
        User::where('id',$user_id)->update($updateData);
        $request->session()->forget('uv_user_id');
    }

    public function resend(Request $request) {
        $user_id = session('uv_user_id');
        $user = User::where('id',$user_id)->first();
        $code = mt_rand(100000, 999999);
        $request->session()->put('code', $code);
        Mail::to($user->email)->send(new VerificationMail());
        return redirect("verification");
    }

    public function logout(Request $request) {
        $request->session()->flush();
        return redirect('login');
    }
}
