<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Customer;
use App\AdminPurchaesInvoice;
use App\supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\ClassOfAccount;
use Carbon\Carbon;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use PDF;
use Auth;
use App\WarehouseTransfer;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use App\PurchaseInvoiceExpense;
use App\AdminSalesInvoiceExpense;
use App\AdminItemGroup;
use App\ItemName;
use Illuminate\Support\Facades\DB;
use App\Services\StockReportService;
use App\Services\ProfitAndLossService;
use App\Services\AllAccountsObWithTransactionService;
use App\Services\CashReportService;
use App\Services\VatReportService;
use App\Services\ProfitAndLossLedgerReportServise;
use App\Services\ProfitAndLossCurrentPeriodService;
use App\Services\TrialBalanceOpeningBalanceForBalanceSheetService;



class BalanceSheetController extends Controller
{
    protected $stockReportService;
    protected $profitAndLossService;
    protected $AllAccountsObWithTransactionService;
    protected $cashReportService;
    protected $vatReportService;
    protected $profitAndLossLedgerReportServise;
    protected $profitAndLossCurrentPeriodService;
    protected $trialBalanceOpeningBalanceForBalanceSheetService;

    public function __construct(StockReportService $stockReportService, ProfitAndLossService $profitAndLossService,AllAccountsObWithTransactionService $AllAccountsObWithTransactionService,CashReportService $cashReportService,VatReportService $vatReportService,ProfitAndLossLedgerReportServise $profitAndLossLedgerReportServise,
    ProfitAndLossCurrentPeriodService $profitAndLossCurrentPeriodService,
    TrialBalanceOpeningBalanceForBalanceSheetService $trialBalanceOpeningBalanceForBalanceSheetService
    ) {
        $this->stockReportService = $stockReportService;
        $this->profitAndLossService = $profitAndLossService;
        $this->AllAccountsObWithTransactionService = $AllAccountsObWithTransactionService;
        $this->cashReportService = $cashReportService;
        $this->vatReportService = $vatReportService;
        $this->profitAndLossLedgerReportServise = $profitAndLossLedgerReportServise;
        $this->profitAndLossCurrentPeriodService = $profitAndLossCurrentPeriodService;
        $this->trialBalanceOpeningBalanceForBalanceSheetService = $trialBalanceOpeningBalanceForBalanceSheetService;
    }

    public function balanceSheet(request $request)
    {
        $from_date = $request->to_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));


        /// -------------------------- All Fixed Assets Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($FixedAssetsMergedAccountDetails,$FixedAssetsTotalDebit,$FixedAssetsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllFixedAssetsClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit);

        // Complete Stock Opening & Closing Balance

        list($groupedItems, $groups, $from_date, $to_date,$allClosingStock,$allOpeningStock) = $this->stockReportService->completeStockReportClosingBalanceAndOpeningBalance($request, $request->from_date, $request->to_date);

        //  dd($allClosingStock,$allOpeningStock);

        /// -------------------------- All Advance Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($AdvanceTotalDebit,$AdvanceTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllAdvanceClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($AdvanceTotalDebit,$AdvanceTotalCredit);

        /// -------------------------- All Sundry Debtors Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllSundryDebtorsClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit);


        // ------------------------- Cash Report Data -----------------------------------------------------

       list($debitCashReportCB,$creditCashReportCB) = $this->cashReportService->CashReportServiceClosingBalance($request, $request->from_date, $request->to_date);

        /// ------------------------ All Bank Accounts Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($bankAccountTotalDebit,$bankAccountTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllBankAccountClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($bankAccountTotalDebit,$bankAccountTotalCredit);

        /// -------------------------- All Capital Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CapitalAccountDetails,$CapitalAccountTotalDebit,$CapitalAccountTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCapitalAccountClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CapitalAccountTotalDebit,$CapitalAccountTotalCredit);

        /// -------------------------- All Loans Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($LoansAccountDetails,$loansTotalDebit,$loansTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllLoansClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($loansTotalDebit,$loansTotalCredit);

        // --------------------------- Vat Report Amount --------------------------------

       list($debitVatReportCB,$creditVatReportCB) = $this->vatReportService->vatReportClosingBalance($request, $request->from_date, $request->to_date);

       // dd($debitVatReportCB,$creditVatReportCB);

        /// -------------------------- All Sundry Creditors Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllSundryCreditorsClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit);

        /// -------------------------- All Current Liabilities Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CurrentLiabilitiesAccountDetails,$CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCurrentLiabilitiesClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit);

        /// -------------------------- Profit And Loss Ledger Report --------------->>>>>>>>>>>>>>>>>>



        // list($ProfitAndLossLedgerReportDebitCB,$ProfitAndLossLedgerReportCreditCB, $from_date, $to_date) = $this->profitAndLossLedgerReportServise->ProfitAndLossLedgerReportServise($request, $request->from_date, $request->to_date);

        // dd($ProfitAndLossLedgerReportDebitCB,$ProfitAndLossLedgerReportCreditCB);



        /// -------------------------- Trial Balance Opening Balance For Balance Sheet Service --------------->>>>>>>>>>>>>>>>>>

        list($DebitBalance,$CreditBalance) = $this->trialBalanceOpeningBalanceForBalanceSheetService->trialBalanceOpeningBalanceForBalanceSheet($request, $request->from_date, $request->to_date);

        // dd($DebitBalance,$CreditBalance);

        /// -------------------------- Profit And Loss Current Period Report --------------->>>>>>>>>>>>>>>>>>

        list($netProfit) = $this->profitAndLossCurrentPeriodService->profitLossCurrentPeriodReports($request, $request->from_date, $request->to_date);

        // dd($netProfit);

        return view('crusher.reports.balance_sheet',compact('from_date','to_date','FixedAssetsMergedAccountDetails','FixedAssetsTotalDebit','FixedAssetsTotalCredit','allClosingStock','allOpeningStock','AdvanceTotalDebit','AdvanceTotalCredit','sundryDebtorsTotalDebit','sundryDebtorsTotalCredit','debitCashReportCB','creditCashReportCB','bankAccountTotalDebit','bankAccountTotalCredit','CapitalAccountTotalDebit','CapitalAccountTotalCredit','CapitalAccountDetails','loansTotalDebit','loansTotalCredit','LoansAccountDetails','debitVatReportCB','creditVatReportCB','SundryCreditorsTotalDebit','SundryCreditorsTotalCredit','CurrentLiabilitiesAccountDetails','CurrentLiabilitiesTotalDebit','CurrentLiabilitiesTotalCredit','debitCashReportCB','netProfit','DebitBalance','CreditBalance'));
    }
    public function view()
    {
        return view('crusher.reports.select-balance-sheet');
    }
    public function viewBbbb()
    {
        return view('crusher.reports.bbbb');
    }
}
