<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Customer;
use App\AdminPurchaesInvoice;
use App\Supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\ClassOfAccount;
use Carbon\Carbon;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use PDF;
use Auth;
use App\WarehouseTransfer;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use App\PurchaseInvoiceExpense;
use App\AdminSalesInvoiceExpense;
use App\AdminItemGroup;
use App\ItemName;
use Illuminate\Support\Facades\DB;
use App\Services\StockReportService;
use App\Services\AllAccountsObWithTransactionService;
use App\Services\CashReportService;
use App\Services\VatReportService;
use App\Services\DiscountReportService;
use App\Services\TrialBalanceExpense;
use App\Services\TrialBalanceIncom;

class TrailBalanceReportController extends  Controller
{
    protected $stockReportService;
    protected $AllAccountsObWithTransactionService;
    protected $discountReportService;
    protected $vatReportService;
    protected $cashReportService;
    protected $TrialBalanceExpense;
    protected $TrialBalanceIncom;

    public function __construct(
        VatReportService $vatReportService,
        CashReportService $cashReportService,
        DiscountReportService $discountReportService,
        StockReportService $stockReportService,
        AllAccountsObWithTransactionService $AllAccountsObWithTransactionService,
        TrialBalanceExpense $TrialBalanceExpense,
        TrialBalanceIncom $TrialBalanceIncom

        ) {
        $this->vatReportService = $vatReportService;
        $this->cashReportService = $cashReportService;
        $this->discountReportService = $discountReportService;
        $this->stockReportService = $stockReportService;
        $this->AllAccountsObWithTransactionService = $AllAccountsObWithTransactionService;
        $this->TrialBalanceExpense = $TrialBalanceExpense;
        $this->TrialBalanceIncom = $TrialBalanceIncom;

    }

    public function view()
    {
        return view('crusher.reports.trail_balance_report');
    }

    public function trailBalanceReport(Request $request)

    {

        // All Accounts Create Opening Balance With Transaction Amounts Service

        // list($totalDebit,$totalCredit,$obtotalDebit,$obtotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllAccountsCreateOpeningBalanceWithAllTransactionClosingBalance($request, $request->from_date, $request->to_date);

        // dd($totalDebit,$totalCredit,$obtotalDebit,$obtotalCredit);

        $lastFromDate = date("2003-01-01");
        $from_date = $request->to_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));





       // Vat Report Amount --------------------------------

       list($debitVatReportCB,$creditVatReportCB) = $this->vatReportService->vatReportClosingBalance($request, $request->from_date, $request->to_date);

       // dd($debitVatReportCB,$creditVatReportCB);

       // Cash Report Data -----------------------------------------------------

       list($debitCashReportCB,$creditCashReportCB) = $this->cashReportService->CashReportServiceClosingBalance($request, $request->from_date, $request->to_date);

       // Vat Report Data -----------------------------------------------------

       list($debitDiscountReportCB,$creditDiscountReportCB) = $this->discountReportService->DiscountReportServiceClosingBalance($request, $request->from_date, $request->to_date);



        $classOfAccount = ClassOfAccount::all();

        $allAccounts = collect();

        $customers = Customer::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $staffAndSalesmen = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $expenses = Expense::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();

        $allAccounts = $allAccounts->merge($customers)->merge($staffAndSalesmen)->merge($suppliers)->merge($expenses)->merge($adminOtherAccounts);

        $totalDebit = [];
        $totalCredit = [];
        $processedAccounts = [];
        $mergedAccounts = [];
        $ObMergedAccounts = [];

        $obtotalDebit = [];
        $obtotalCredit = [];
        foreach ($allAccounts as $account) {
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $ReceiptVoucher = ReceiptVoucherExpense::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('invoice_no')
                ->get();

            $PaymentVoucher = PaymentVoucherExpense::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $CreditNote = CreditNote::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $DebitNote = DebitNote::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $TotalPurchaesInvoice = $PurchaesInvoice->sum('total_net_amount');
            $TotalDebitNote = $DebitNote->sum('total_net_amount');
            $TotalPaymentVoucher = $PaymentVoucher->sum('amount');

            $TotalSaleInvoice = $SaleInvoice->sum('total_net_amount');
            $TotalReceiptVoucher = $ReceiptVoucher->sum('amount');
            $TotalCreditNote = $CreditNote->sum('total_net_amount');

            $totalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucher + $TotalDebitNote;
            $totalCreditValue = $TotalPurchaesInvoice + $TotalReceiptVoucher + $TotalCreditNote ;

            // $totalDebit[] = [
            //     'account_id' => $account->class_of_account_id,
            //     'DebitBalance' => $totalDebitValue,
            // ];

            // $totalCredit[] = [
            //     'account_id' => $account->class_of_account_id,
            //     'creditBalance' => $totalCreditValue,
            // ];

            $totalDebit[] = [
                'account_id' => $account->class_of_account_id,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'DebitBalance' => $totalDebitValue,
            ];

            // Check if the account type is 'Debit' and update 'DebitBalance' accordingly
            if ($account->type == 'Debit') {
                $totalDebit[count($totalDebit) - 1]['DebitBalance'] += $account->opening_balance;
            }


            $totalCredit[] = [
                'account_id' => $account->class_of_account_id,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'creditBalance' => $totalCreditValue,
            ];

            // Check if the account type is 'Credit' and update 'creditBalance' accordingly
            if ($account->type == 'Credit') {
                $totalCredit[count($totalCredit) - 1]['creditBalance'] += $account->opening_balance;
            }
            // dd($totalDebit,$totalCredit);

        }
        foreach ($allAccounts as $account) {
            $ObPurchaesInvoice = AdminPurchaesInvoice::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $ObSaleInvoice = AdminSalesInvoice::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $ObReceiptVoucher = ReceiptVoucherExpense::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                // ->groupBy('invoice_no')
                ->get();

            $ObPaymentVoucher = PaymentVoucherExpense::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $ObCreditNote = CreditNote::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $ObDebitNote = DebitNote::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $ObTotalPurchaesInvoice = $ObPurchaesInvoice->sum('total_net_amount');
            $ObTotalDebitNote = $ObDebitNote->sum('total_net_amount');
            $ObTotalPaymentVoucher = $ObPaymentVoucher->sum('amount');

            $ObTotalSaleInvoice = $ObSaleInvoice->sum('total_net_amount');
            $ObTotalReceiptVoucher = $ObReceiptVoucher->sum('amount');
            $ObTotalCreditNote = $ObCreditNote->sum('total_net_amount');

            $ObtotalDebitValue = $ObTotalSaleInvoice + $ObTotalPaymentVoucher + $ObTotalDebitNote;
            $ObtotalCreditValue = $ObTotalPurchaesInvoice + $ObTotalReceiptVoucher + $ObTotalCreditNote;


            // $obtotalDebit[] = [
            //     'account_id' => $account->class_of_account_id,
            //     'DebitBalance' => $ObtotalDebitValue,
            // ];

            // $obtotalCredit[] = [
            //     'account_id' => $account->class_of_account_id,
            //     'creditBalance' => $ObtotalCreditValue,
            // ];

            $obtotalDebit[] = [
                'account_id' => $account->class_of_account_id,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'DebitBalance' => $totalDebitValue,
            ];

            // Check if the account type is 'Debit' and update 'DebitBalance' accordingly
            if ($account->type == 'Debit') {
                $obtotalDebit[count($obtotalDebit) - 1]['DebitBalance'] += $account->opening_balance;
            }


            $obtotalCredit[] = [
                'account_id' => $account->class_of_account_id,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'creditBalance' => $totalCreditValue,
            ];

            // Check if the account type is 'Credit' and update 'creditBalance' accordingly
            if ($account->type == 'Credit') {
                $obtotalCredit[count($obtotalCredit) - 1]['creditBalance'] += $account->opening_balance;
            }
        }


        $CbMergedAccounts = [];

        // Assuming $totalDebit and $obtotalDebit are already populated
        foreach ($allAccounts as $index => $account) {
            $currentTotalDebit = $totalDebit[$index]['DebitBalance'] ?? 0;
            $currentTotalCredit = $totalCredit[$index]['creditBalance'] ?? 0;

            $ObDebitBalance = $obtotalDebit[$index]['DebitBalance'] ?? 0;
            $ObCreditBalance = $obtotalCredit[$index]['creditBalance'] ?? 0;

            $totalDebitValue = $currentTotalDebit + $ObDebitBalance;
            $totalCreditValue = $currentTotalCredit + $ObCreditBalance;

            $ClosingBalance = $totalDebitValue - $totalCreditValue;

            // Determine whether to use debit or credit closing balance
            if ($ClosingBalance < 0) {
                $debitClosingBalance = 0;
                $creditClosingBalance = abs($ClosingBalance);
            } else {
                $debitClosingBalance = $ClosingBalance;
                $creditClosingBalance = 0;
            }

            // Merge entries with the same account_id
            $accountId = $account->class_of_account_id;
            if (!isset($CbMergedAccounts[$accountId])) {
                $CbMergedAccounts[$accountId] = [
                    'account_id' => $accountId,
                    'name' => optional($account->classOfAccount)->name,
                    'totalDebit' => $totalDebitValue,
                    'totalCredit' => $totalCreditValue,
                    'debitClosingBalance' => $debitClosingBalance,
                    'creditClosingBalance' => $creditClosingBalance,
                ];
            } else {
                // If entry with the same account_id exists, merge the values
                $CbMergedAccounts[$accountId]['totalDebit'] += $totalDebitValue;
                $CbMergedAccounts[$accountId]['totalCredit'] += $totalCreditValue;
                $CbMergedAccounts[$accountId]['debitClosingBalance'] += $debitClosingBalance;
                $CbMergedAccounts[$accountId]['creditClosingBalance'] += $creditClosingBalance;
            }
        }

        // Convert the associative array back to indexed array if needed
        $CbMergedAccounts = array_values($CbMergedAccounts);

        // dd($CbMergedAccounts);








        /// -------------------------- All Sundry Debtors Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllSundryDebtorsClassofAccountsForTrialBalance($request, $request->from_date, $request->to_date);

        // dd($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit);

        /// -------------------------- All Bank Accounts Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($bankAccountTotalDebit,$bankAccountTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllBankAccountClassofAccountsForTrialBalance($request, $request->from_date, $request->to_date);

        // dd($bankAccountTotalDebit,$bankAccountTotalCredit);

        /// -------------------------- All Sundry Creditors Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllSundryCreditorsClassofAccountsForTrialBalance($request, $request->from_date, $request->to_date);

        // dd($SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit);

        /// -------------------------- All Current Liabilities Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CurrentLiabilitiesAccountDetails,$CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCurrentLiabilitiesClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit);



        // All Accounts Create Opening Balance With Transaction Amounts Service

        list($groupedAccountDetails, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllAccountsCreateOpeningBalanceWithTransactionAmountsService($request, $request->from_date, $request->to_date);

        // dd($groupedAccountDetails);

        // complete stock Opening & Closing Balance

        list($groupedItems, $groups, $from_date, $to_date,$allClosingStock,$allOpeningStock) = $this->stockReportService->completeStockReportClosingBalanceAndOpeningBalance($request, $request->from_date, $request->to_date);

        // dd($allClosingStock,$allOpeningStock);


        // All Purchaes Invoice Totals

        $AllPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get()
            ->sum('total_gross_amount');

        $AllDebitNoteInvoice = DebitNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllPurchaesTotals = $AllPurchaesInvoice - $AllDebitNoteInvoice;

        // All Sales Invoice Totals

        $AllSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllCreditNoteInvoice = CreditNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        // $AllSaleTotals = $AllSaleInvoice - $AllCreditNoteInvoice;

        $grandTotalDebit = 0;
        $grandTotalCredit = 0;

        if ($AllCreditNoteInvoice > $AllSaleInvoice) {
            $grandTotalDebit = $AllCreditNoteInvoice - $AllSaleInvoice;
        } else {
            $grandTotalCredit = $AllSaleInvoice - $AllCreditNoteInvoice;
        }

        $AllSaleTotalsDebit = $grandTotalDebit;
        $AllSaleTotalsCredit = $grandTotalCredit;

        // extra expenses

        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $purchaseInvoiceExpenses = PurchaseInvoiceExpense::whereIn('admin_purchase_invoice_id', $purchaseInvoices->pluck('id'))
            ->get();

        $mergedPurchaseExpenses = $purchaseInvoiceExpenses
        ->groupBy('admin_purchase_invoice_id')
        ->map(function ($group) {
            return [
                'account_name' => $group->first()->account_name,
                'total_expense_amount' => $group->sum('expense_amount'),
            ];
        })
        ->values();

        $SalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();
        $salesInvoiceExpenses = AdminSalesInvoiceExpense::whereIn('admin_sales_invoice_id', $SalesInvoices->pluck('id'))
                ->get();

        $mergedSalesExpenses = $salesInvoiceExpenses
        ->groupBy('admin_sales_invoice_id')
        ->map(function ($group) {
            return [
                'account_name' => $group->first()->account_name,
                'total_expense_amount' => $group->sum('expense_amount'),
            ];
        })
        ->values();

        $PaymentInvoices = AdminPaymentVoucher::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();
        $paymentInvoiceExpenses = PaymentVoucherExpense::whereIn('voucher_id', $PaymentInvoices->pluck('id'))
                ->get();

        $mergedPaymentExpenses = $paymentInvoiceExpenses
        ->groupBy('voucher_id')
        ->map(function ($group) {
            return [
                'account_name' => $group->first()->account_name,
                'amount' => $group->sum('amount'),
            ];
        })
        ->values();

        // Trial Balance Expense -------------------------------

        list($expenseTotalClosingBalance) = $this->TrialBalanceExpense->TrialBalanceExpenses($request, $request->from_date, $request->to_date);

        // dd($expenseTotalClosingBalance);

        // Trial Balance Income --------------------------------

        list($incomeTotalClosingBalance) = $this->TrialBalanceIncom->TrialBalanceIncoms($request, $request->from_date, $request->to_date);

        // dd($incomeTotalClosingBalance);

        list($fixedTotalClosingBalance) = $this->TrialBalanceIncom->TrialBalanceFixedAssetsForBalanceSheet($request, $request->from_date, $request->to_date);

        // dd($fixedTotalClosingBalance);

        /// -------------------------- All Capital Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CapitalAccountDetails,$CapitalAccountTotalDebit,$CapitalAccountTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCapitalAccountClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CapitalAccountTotalDebit,$CapitalAccountTotalCredit);

        /// -------------------------- All Advance Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($AdvanceTotalDebit,$AdvanceTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllAdvanceClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($AdvanceTotalDebit,$AdvanceTotalCredit);

        /// -------------------------- All Loans Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($LoansAccountDetails,$loansTotalDebit,$loansTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllLoansClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($loansTotalDebit,$loansTotalCredit);


        return view('crusher.reports.trail_balance_reports', compact('from_date', 'to_date', 'totalDebit','totalCredit','mergedAccounts','classOfAccount','AllPurchaesInvoice','AllSaleInvoice','allAccounts','mergedPurchaseExpenses','mergedSalesExpenses','mergedPaymentExpenses','AllPurchaesTotals','AllSaleTotalsDebit','AllSaleTotalsCredit','allOpeningStock','groupedAccountDetails','debitVatReportCB','creditVatReportCB','debitCashReportCB','creditCashReportCB','debitDiscountReportCB','creditDiscountReportCB','expenseTotalClosingBalance','incomeTotalClosingBalance','sundryDebtorsTotalDebit','sundryDebtorsTotalCredit','bankAccountTotalDebit','bankAccountTotalCredit','SundryCreditorsTotalDebit','SundryCreditorsTotalCredit','CurrentLiabilitiesTotalDebit','CurrentLiabilitiesTotalCredit','CapitalAccountTotalDebit','CapitalAccountTotalCredit','AdvanceTotalDebit','AdvanceTotalCredit','loansTotalDebit','loansTotalCredit','fixedTotalClosingBalance'));
    }

}

