<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;

class VatReportController extends Controller
{
    public function display()
    {

        return view('crusher.reports.vat_ledger_report_display');
    }
    public function vatLedgerReport(Request $request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $createObVat = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->where('account_name', 'VAT')
            ->first();

            if ($createObVat) {
                $VatAccountId = $createObVat->id;
                $VatAccountDate = $createObVat->date;
                if ($createObVat->type == 'debit') {
                    $createDebitOB = $createObVat->opening_balance;
                    $createCreditOB = null;
                } elseif ($createObVat->type == 'credit') {
                    $createDebitOB = null;
                    $createCreditOB = $createObVat->opening_balance;
                } else {
                    $createDebitOB = null;
                    $createCreditOB = null;
                }
            } else {
                $VatAccountId = null;
                $VatAccountDate = null;
                $createDebitOB = null;
                $createCreditOB = null;
            }

        $createObalanceVat = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->where('account_name', 'VAT')
            ->first();

            if ($createObalanceVat) {
                $obVatAccountId = $createObalanceVat->id;
                // $VatAccountDate = $createObalanceVat->date;
                if ($createObalanceVat->type == 'debit') {
                    $createDebitOBalance = $createObalanceVat->opening_balance;
                    $createCreditOBalance = null;
                } elseif ($createObalanceVat->type == 'credit') {
                    $createDebitOBalance = null;
                    $createCreditOBalance = $createObalanceVat->opening_balance;
                } else {
                    $createDebitOBalance = null;
                    $createCreditOBalance = null;
                }
            } else {
                $obVatAccountId = null;
                // $VatAccountDate = null;
                $createDebitOBalance = null;
                $createCreditOBalance = null;
            }

        // dd($VatAccountId,$createDebitOB,$createCreditOB);

        $customer = Customer::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $supplier = Supplier::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $expense = Expense::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $adminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->get()->toArray();

        $allAccounts = array_merge($customer, $staffAndSalesman, $supplier, $expense, $adminOtherAccount);

        // $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
        //     ->where('date', '>=', $from_date . ' 00:00:00')
        //     ->where('date', '<=', $to_date . ' 23:59:59')
        //     ->groupBy('invoice_no')
        //     ->orderBy('invoice_no', 'asc')
        //     ->get()
        //     ->toArray();

        $ncustomer = Customer::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nsupplier = Supplier::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nexpense = Expense::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nadminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();

        $allAccountIds = array_merge($ncustomer, $nstaffAndSalesman, $nsupplier, $nexpense, $nadminOtherAccount);

        $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('invoice_no', 'asc')
            ->get();

        $SaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $CreditNote = CreditNote::with('expense')->where('branch_id', session()->get('selected_branch'))
        ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();
        $DebitNote = DebitNote::with('expense')->where('branch_id', session()->get('selected_branch'))
        ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        // $PaymentVoucher = PaymentVoucherExpense::where('branch_id', session()->get('selected_branch'))
        //     ->whereIn('account_id', $allAccountIds)
        //     ->where('date', '>=', $from_date . ' 00:00:00')
        //     ->where('date', '<=', $from_date . ' 23:59:59')
        //     ->groupBy('invoice_no')
        //     ->orderBy('date', 'asc')
        //     ->get();

        $PaymentVouchers = AdminPaymentVoucher::with('expense')
        ->where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        ->whereNull('deleted_at')
        ->groupBy('invoice_no')
        ->orderBy('date', 'asc')
        ->get();

        foreach ($PaymentVouchers as $PaymentVoucher) {
            $mergedExpenses = $PaymentVoucher->expense
                ->whereIn('account_id', $allAccountIds)
                ->groupBy('invoice_no')
                ->map(function ($group) {
                    return [
                        'invoice_no' => $group->first()->invoice_no,
                        'total_amount' => $group->sum('new_vat_amount'),
                    ];
                })
                ->values();

            $PaymentVoucher->mergedExpenses = $mergedExpenses;
        }

        // dd($PaymentVouchers);


        // dd($PaymentVouchers);

        $PurchaseOrder = PurchaseOrder::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $from_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $allData = $PurchaesInvoice ->concat($SaleInvoice)->concat($CreditNote)->concat($DebitNote)->concat($PaymentVouchers)->concat($PurchaseOrder);

        // dd($allData);

        $ObPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObCreditNote = CreditNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObDebitNote = DebitNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObPurchaseOrder = PurchaseOrder::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObQuotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('quotation_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObPaymentVouchers = AdminPaymentVoucher::with('expense')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get();

            $mergedReceipts = $ObPaymentVouchers->flatMap(function ($receiptVoucher) {
                return $receiptVoucher->expense->groupBy('invoice_no')->map(function ($group) {
                    return [
                        'invoice_no' => $group->first()->invoice_no,
                        'total_vat_amount' => $group->sum('new_vat_amount'),
                    ];
                });
            });

            $ObObPaymentVouchersTotalAmount = $mergedReceipts->sum('total_vat_amount');

            $ObDebit =null;
            $ObCredit =null;

            $ObdebitTotal = $createDebitOBalance + $ObPurchaesInvoice + $ObCreditNote + $ObPurchaseOrder + $ObQuotation + $ObObPaymentVouchersTotalAmount;
            $ObcreditTotal = + $createCreditOBalance + $ObSaleInvoice  + $ObDebitNote;
            // dd($ObdebitTotal,$ObcreditTotal);

            if ($ObdebitTotal > $ObcreditTotal) {
                $ObDebit = $ObdebitTotal - $ObcreditTotal;
            } elseif ($ObdebitTotal < $ObcreditTotal) {
                $ObCredit = $ObcreditTotal - $ObdebitTotal;
            }

            $DebitopeningBalance = $ObDebit;
            $creditOpeningBalance = $ObCredit;

            // dd($ObdebitTotal,$ObcreditTotal);


        $purchaesInvoiceData = [];
        $saleInvoiceData = [];
        $CreditNoteData = [];
        $DebitNoteData = [];
        $PurchaseOrderData = [];
        $QuotationData = [];

        $ObpurchaesInvoiceData = [];
        $ObsaleInvoiceData = [];
        $ObCreditNoteData = [];
        $ObDebitNoteData = [];
        $ObPurchaseOrderData = [];
        $ObQuotationData = [];
        $ObPaymentVouchers = [];


        $saleInvoiceData = collect($saleInvoiceData);
        $purchaesInvoiceData = collect($purchaesInvoiceData);
        $CreditNoteData = collect($CreditNoteData);
        $DebitNoteData = collect($DebitNoteData);
        $PurchaseOrderData = collect($PurchaseOrderData);
        $QuotationData = collect($QuotationData);


        // $allData = $saleInvoiceData ->concat($purchaesInvoiceData)->concat($CreditNoteData)->concat($DebitNoteData)->concat($PurchaseOrderData)->concat($QuotationData);

        // dd($allData);


        // dd('Purchaes Invoice Data:', $purchaesInvoiceData, 'Sale Invoice Data:', $saleInvoiceData, 'Journal Voucher Match', $JournalVoucherMatch , 'Receipt Voucher Data', $ReceiptVoucherData);

        // dd($ObsaleInvoiceData,$ObpurchaesInvoiceData);

        return view('crusher.reports.vvat-ledger-report', compact('VatAccountDate','from_date', 'to_date','allAccounts', 'saleInvoiceData','purchaesInvoiceData','CreditNoteData','DebitNoteData','PurchaseOrderData','QuotationData','ObsaleInvoiceData','ObpurchaesInvoiceData','ObCreditNoteData','ObDebitNoteData','ObPurchaseOrderData','ObQuotationData','ObPaymentVouchers','allData','createDebitOB','createCreditOB','createDebitOBalance','createCreditOBalance','DebitopeningBalance','creditOpeningBalance'));
    }
}


