<?php

namespace App\Services;

use Illuminate\Http\Request;
use App\AdminSalesInvoice;
use App\AdminPurchaesInvoice;
use Carbon\Carbon;
use App\Branches;
use App\AdminItemGroup;
use App\ItemName;
use App\Customer;
use App\debitNote;
use App\creditNote;
use App\OpeningBalance;
use App\PurchaseInvoiceExpense;
use App\AdminSalesInvoiceExpense;
use App\AdminPaymentVoucher;
use App\PaymentVoucherExpense;
use App\Supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\Company;
use App\DeliveryNote;
use App\PurchaseOrder;
use App\Quotation;
use App\ClassOfAccount;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use PDF;
use Auth;
use App\WarehouseTransfer;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;
use App\Services\StockReportService;
use App\Services\TrialBalanceIncom;
use App\Services\TrialBalanceExpense;

class ProfitAndLossOpeningBalanceService
{

    protected $stockReportService;
    protected $TrialBalanceIncom;
    protected $TrialBalanceExpense;

    public function __construct(StockReportService $stockReportService,TrialBalanceIncom $TrialBalanceIncom,TrialBalanceExpense $TrialBalanceExpense) {
        $this->stockReportService = $stockReportService;
        $this->TrialBalanceIncom = $TrialBalanceIncom;
        $this->TrialBalanceExpense = $TrialBalanceExpense;
    }

    public function profitAndLossOBReports(Request $request)
    {
        $from_date = $request->to_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $from_date = date("2003-01-01");
        $to_date = date('Y-m-d', strtotime('-1 day', strtotime($to_date)));

        // dd($from_date,$to_date);

        // complete stock Opening & Closing Balance

         list($groupedItems, $groups, $from_date, $to_date,$allClosingStock,$allOpeningStock) = $this->stockReportService->completeStockReportClosingBalanceAndOpeningBalanceForProfitAndLossLedgerReport($request, $request->from_date, $request->to_date);

        //  dd($allOpeningStock);

        // All Purchaes Invoice Totals

        $AllPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');
        $AllDebitNoteInvoice = DebitNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllPurchaesTotals = $AllPurchaesInvoice - $AllDebitNoteInvoice;


        // All Sales Invoice Totals

        $AllSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllCreditNoteInvoice = CreditNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllSaleTotals = $AllSaleInvoice - $AllCreditNoteInvoice;


        // Trial Balance Income --------------------------------

        list($incomeTotalClosingBalance) = $this->TrialBalanceIncom->TrialBalanceIncomsForBalanceSheet($request, $request->from_date, $request->to_date);

        // dd($incomeTotalClosingBalance);

        // Trial Balance Expense -------------------------------

        list($expenseTotalClosingBalance) = $this->TrialBalanceExpense->TrialBalanceExpensesForProfitAndLossLedgerReport($request, $request->from_date, $request->to_date);


        $incomeTotalCB = 0;
        $expenseTotalCB = 0;

        foreach ($incomeTotalClosingBalance as $accountName => $closingBalance) {

            $incomeTotalCB += -$closingBalance;

        }

        foreach ($expenseTotalClosingBalance as $accountName => $closingBalance) {
            $expenseTotalCB += $closingBalance;

        }

        $costOfSales = ($allOpeningStock + $AllPurchaesTotals) - $allClosingStock;

        $GrossAmount = $AllSaleTotals - abs($costOfSales);

        $GrossPlusIncom = $GrossAmount + $incomeTotalCB;

        $OpeningBalanceNetProfit = $expenseTotalCB - $GrossPlusIncom;

        // dd($costOfSales,$GrossAmount,$GrossPlusIncom,$OpeningBalanceNetProfit);

        // dd($OpeningBalanceNetProfit);

        return [$OpeningBalanceNetProfit];

    }

}
