@extends('layouts.crusher')
@section('content')
    <style>
        body[data-layout=detached] #layout-wrapper::after {
            background: url(../images/bg-effect.png) center;
            content: "";
            position: absolute;
            top: 0;
            left: 0;
            right: 0;
            width: 100%;
            height: 144px;
            background-size: cover;
            opacity: .03;
        }
    </style>

    @if ($user->terms_accept === 0)
        <!-- Show the Terms and Conditions modal -->
        @include('crusher.terms_modal')
    @endif

    {{-- <div class="page-content"> --}}

    @if (session('success'))
        <div class="alert alert-success">
            {{ session('success') }}
        </div>
    @endif

    <!-- start page title -->
    {{-- <div class="row">
            <div class="col-12">
                <div class="page-title-box d-flex align-items-center justify-content-between">
                    <div class="font-size-16 col-md-8" id="dashboardText">
                        @if (!session('selected_branch'))
                            <h4>Dashboard</h4>
                        @else
                            <h4>{{ $selectedBranch->company->name }} | {{ $selectedBranch->name }}</h4>
                        @endif
                    </div>


                    <div class="page-title-right">
                        <ol class="breadcrumb m-0">
                            <h4 class="page-title mb-0 font-size-18">Powered By ACP</h4>
                        </ol>
                    </div>

                </div>
            </div>
        </div> --}}
    <!-- end page title -->
    {{-- @dd($expire) --}}
    <div class="row">
        @forelse ($branches as $key=>$branch)
            <div class="col-xl-3">
                <div class="card">
                    <div class="card-body">
                        <div class="media">
                            <div class="media-body">
                                <div class="row">
                                    <div class="font-size-16 col-md-8">{{ $branch->company->name }} |
                                        {{ $branch->name }}</div>
                                    <div class="col-md-4">
                                        <div class="custom-control custom-switch mb-2 float-right" dir="ltr">
                                            <input type="checkbox" class="custom-control-input selectallmaster"
                                                id="customSwitch{{ $branch->id }}"
                                                data-company-name="{{ $branch->company->name }}"
                                                data-branch-name="{{ $branch->name }}"
                                                onchange="toggleSwitch({{ $branch->id }})"
                                                {{ session('selected_branch') == $branch->id ? 'checked' : '' }}>
                                            <label class="custom-control-label titlcust"
                                                for="customSwitch{{ $branch->id }}">
                                            </label>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <h4 class="mt-4" id="pricehidden{{ $branch->id }}">1,368</h4>
                        <div class="row" id="progress{{ $branch->id }}">
                            <div class="col-7">
                                <p class="mb-0"><span class="text-success mr-2">0.28% <i
                                            class="mdi mdi-arrow-up"></i></span></p>
                            </div>
                            <div class="col-5 align-self-center">
                                <div class="progress progress-sm">
                                    <div class="progress-bar bg-primary" role="progressbar" style="width: 62%"
                                        aria-valuenow="62" aria-valuemin="0" aria-valuemax="100"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        @empty
        @endforelse
    </div>
    <!-- end row -->


    <div class="row">
        <div class="col-xl-8">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Total Sales Month Wise</h4>

                    <div id="line-chart" class="apex-charts"></div>


                </div>
            </div>
        </div>
        <div class="col-xl-4">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Total Sales</h4>

                    <div id="column-chart" class="apex-charts"></div>
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xl-8">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Total Sales Day wise</h4>

                    <div id="line-chart-day-wise" class="apex-charts"></div>


                </div>
            </div>
        </div>
        <div class="col-xl-4">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Total Sales Last 7 Day Wise</h4>

                    <div id="column-chart-7-wise" class="apex-charts"></div>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xl-8">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Total Purchase Month Wise</h4>

                    <div id="line-chart-purchase" class="apex-charts"></div>


                </div>
            </div>
        </div>
        <div class="col-xl-4">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Total Purchase</h4>

                    <div id="column-chart-purchase" class="apex-charts"></div>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-lg-4">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Inbox</h4>

                    <ul class="inbox-wid list-unstyled">
                        <li class="inbox-list-item">
                            <a href="#">
                                <div class="media">
                                    <div class="mr-3 align-self-center">
                                        <img src="assets/images/users/avatar-3.jpg" alt=""
                                            class="avatar-sm rounded-circle">
                                    </div>
                                    <div class="media-body overflow-hidden">
                                        <h5 class="font-size-16 mb-1">Paul</h5>
                                        <p class="text-truncate mb-0">Hey! there I'm available</p>
                                    </div>
                                    <div class="font-size-12 ml-2">
                                        05 min
                                    </div>
                                </div>
                            </a>
                        </li>
                        <li class="inbox-list-item">
                            <a href="#">
                                <div class="media">
                                    <div class="mr-3 align-self-center">
                                        <img src="assets/images/users/avatar-4.jpg" alt=""
                                            class="avatar-sm rounded-circle">
                                    </div>
                                    <div class="media-body overflow-hidden">
                                        <h5 class="font-size-16 mb-1">Mary</h5>
                                        <p class="text-truncate mb-0">This theme is awesome!</p>
                                    </div>
                                    <div class="font-size-12 ml-2">
                                        12 min
                                    </div>
                                </div>
                            </a>
                        </li>
                        <li class="inbox-list-item">
                            <a href="#">
                                <div class="media">
                                    <div class="mr-3 align-self-center">
                                        <img src="assets/images/users/avatar-5.jpg" alt=""
                                            class="avatar-sm rounded-circle">
                                    </div>
                                    <div class="media-body overflow-hidden">
                                        <h5 class="font-size-16 mb-1">Cynthia</h5>
                                        <p class="text-truncate mb-0">Nice to meet you</p>
                                    </div>
                                    <div class="font-size-12 ml-2">
                                        18 min
                                    </div>
                                </div>
                            </a>
                        </li>
                        <li class="inbox-list-item">
                            <a href="#">
                                <div class="media">
                                    <div class="mr-3 align-self-center">
                                        <img src="assets/images/users/avatar-6.jpg" alt=""
                                            class="avatar-sm rounded-circle">
                                    </div>
                                    <div class="media-body overflow-hidden">
                                        <h5 class="font-size-16 mb-1">Darren</h5>
                                        <p class="text-truncate mb-0">I've finished it! See you so</p>
                                    </div>
                                    <div class="font-size-12 ml-2">
                                        2hr ago
                                    </div>
                                </div>
                            </a>
                        </li>
                    </ul>

                    <div class="text-center">
                        <a href="#" class="btn btn-primary btn-sm">Load more</a>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-lg-8">
            <div class="card">
                <div class="card-body">
                    <h4 class="card-title mb-4">Latest Transactions</h4>

                    <div class="table-responsive">
                        <table class="table table-centered">
                            <thead>
                                <tr>
                                    <th scope="col">Company Name</th>
                                    <th scope="col">Activation Date</th>
                                    <th scope="col">Expiry Date</th>
                                    <th scope="col">Amount</th>
                                    <th scope="col" colspan="2">Payment Status</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>lorem ipsum</td>
                                    <td>
                                        <a href="#" class="text-body font-weight-medium">15/01/2020</a>
                                    </td>
                                    <td>15/02/2020</td>
                                    <td>$ 125</td>
                                    <td><span class="badge badge-soft-success font-size-12">15 Days
                                            Left</span>
                                    </td>
                                    <td><a href="/superadmin-report-details.html" class="btn btn-primary btn-sm">View</a>
                                    </td>
                                </tr>
                                <tr>
                                    <td>lorem ipsum</td>
                                    <td>
                                        <a href="#" class="text-body font-weight-medium">17/02/2020</a>
                                    </td>
                                    <td>17/03/2020</td>
                                    <td>$ 118</td>
                                    <td><span class="badge badge-soft-danger font-size-12">Expired</span>
                                    </td>
                                    <td><a href="/superadmin-report-details.html" class="btn btn-primary btn-sm">View</a>
                                    </td>
                                </tr>
                                <tr>
                                    <td>lorem ipsum</td>
                                    <td>
                                        <a href="#" class="text-body font-weight-medium">19/01/2020</a>
                                    </td>
                                    <td>19/02/2020</td>
                                    <td>$ 115</td>
                                    <td><span class="badge badge-soft-warning font-size-12">3 Days
                                            Left</span>
                                    </td>
                                    <td><a href="/superadmin-report-details.html" class="btn btn-primary btn-sm">View</a>
                                    </td>
                                </tr>
                                <tr>
                                    <td>Lorem Ipsum</td>
                                    <td>
                                        <a href="#" class="text-body font-weight-medium">22/06/2020</a>
                                    </td>
                                    <td>22/07/2020</td>
                                    <td>$ 121</td>
                                    <td><span class="badge badge-soft-warning font-size-12">5 Days
                                            Left</span>
                                    </td>
                                    <td><a href="/superadmin-report-details.html" class="btn btn-primary btn-sm">View</a>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>

                    <div class="mt-3">
                        <ul class="pagination pagination-rounded justify-content-center mb-0">
                            <li class="page-item">
                                <a class="page-link" href="#">Previous</a>
                            </li>
                            <li class="page-item active"><a class="page-link" href="#">1</a></li>
                            <li class="page-item "><a class="page-link" href="#">2</a></li>
                            <li class="page-item"><a class="page-link" href="#">3</a></li>
                            <li class="page-item"><a class="page-link" href="#">Next</a></li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->

    <div class="row">
        @if (isset($dashboardImage))
            <div class="col-xl-5">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title mb-4">lorem</h4>

                        <div class="row align-items-center">
                            <div class="col-sm-6">
                                <img src="@if (isset($dashboardImage)) ../{{ $dashboardImage->path }} @endif"
                                    width="190px" alt="Image">
                            </div>
                            <div class="col-sm-6">
                                <div>
                                    <div class="row">
                                        <p>{{ $dashboardImage->content ?? '' }}</p>

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        @else
        @endif

        {{-- BRANCH EXPIRY --}}
        <div class="col-sm-6 col-md-4 col-xl-3">
            <div class="my-4 text-center">
                <p class="text-muted">Center modal</p>
                <!-- Small modal -->
                <button type="button" class="btn btn-primary waves-effect waves-light" data-toggle="modal"
                    data-target=".bs-example-modal-center">Center modal</button>
            </div>

            <div class="modal fade bs-example-modal-center" tabindex="-1" role="dialog"
                aria-labelledby="mySmallModalLabel" aria-hidden="true">
                <div class="modal-dialog modal-dialog-centered">
                    <div class="modal-content">

                        <form method="POST" action="/upload-img" enctype="multipart/form-data">
                            @csrf

                            <div class="modal-header">
                                <h5 class="modal-title mt-0">Acount Subscription</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <div class="col-md-12">
                                    <h4 class="card-title">Uploade ScreenShoot</h4>
                                    <p class="card-title-desc">Drop Your ScreenShoot
                                    </p>

                                    <div>
                                        <form action="#" class="dropzone">
                                            <div class="fallback">
                                                <input name="voucher" id="image" type="file" multiple="multiple">
                                            </div>
                                            <div class="dz-message needsclick align-items-center">
                                                <div class=" mb-2">
                                                    <img id="preview-image-before-upload"
                                                        src="https://www.riobeauty.co.uk/images/product_image_not_found.gif"
                                                        alt="preview image" class="img-fluid">
                                                </div>

                                            </div>
                                        </form>
                                    </div>

                                    <div class="text-center mt-4">
                                        <button type="submit" class="btn btn-primary waves-effect waves-light">Send
                                            Files</button>
                                    </div>
                                </div>
                                <br><br><br>

                                <div class="col-md-12">
                                    <h5>Account Number : <span>00000000000000000</span> </h5>
                                    <p>Pay Your Fee</p>
                                </div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                <a href="#">
                                    <button type="button" class="btn btn-primary" data-dismiss="modal">Ok</button>
                                </a>
                            </div>

                        </form>

                    </div>
                    <!-- /.modal-content -->
                </div>
                <!-- /.modal-dialog -->
            </div>
            <!-- /.modal -->


        </div>

        {{-- leniencyExpire --}}
        <div class="col-sm-6 col-md-4 col-xl-3">
            <div class="my-4 text-center">
                <p class="text-muted">Leniency Expire</p>
                <!-- Small modal -->
                <button type="button" class="btn btn-primary waves-effect waves-light" data-toggle="modal"
                    data-target="leniency-expire">Leniency Expire</button>
            </div>

            <div class="modal fade leniency-expire" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel"
                aria-hidden="true">
                <div class="modal-dialog modal-dialog-centered">
                    <div class="modal-content">

                        <form enctype="multipart/form-data">
                            <div>
                                <p>Contact your branch admin</p>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                <a href="#">
                                    <button type="button" class="btn btn-primary" data-dismiss="modal">Ok</button>
                                </a>
                            </div>

                        </form>

                    </div>
                    <!-- /.modal-content -->
                </div>
                <!-- /.modal-dialog -->
            </div>
            <!-- /.modal -->


        </div>

    </div>
    <!-- end row -->


    </div>
    <!-- end row -->

    <!-- apexcharts -->
    <script src="{{ asset('assets/libs/apexcharts/apexcharts.min.js') }}"></script>
    <script src="{{ asset('assets/libs/select2/js/select2.min.js') }}"></script>
    <script src="{{ asset('assets/js/pages/form-advanced.init.js') }}"></script>


    <script src="{{ asset('assets/js/pages/dashboard.init.js') }}"></script>

    <script src="{{ asset('assets/js/common.js') }}"></script>
    <script src="{{ asset('assets/js/app.js') }}"></script>

    <!-- form repeater js -->
    <script src="assets/libs/jquery.repeater/jquery.repeater.min.js"></script>

    <!-- form repeater init -->
    <script src="assets/js/pages/form-repeater.init.js"></script>

    <script src="assets/js/app.js"></script>

    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.js"></script>

    {{-- <script src="{{ asset('assets/js/jquery-3.3.1.min.js') }}"></script> --}}
    <script src="{{ asset('assets/js/jquery.multiselect.js') }}"></script>
    <script src="{{ asset('assets/js/main.js') }}"></script>
    <script type="text/javascript">
        // expire modal
        $(document).ready(function() {
            @if (!empty(session('selected_branch')))
                @if ($expire & $status)
                    // If the 'expire' condition is true, open the modal
                    $('.bs-example-modal-center').modal('show');
                @endif

                @if (!$status)
                    // If the 'leniencyExpire' condition is true or branch status is 0, open the modal
                    $('.leniency-expire').modal('show');
                @endif
            @endif
        });

        // expire modal

        function toggleSwitch(branchId) {
            // Turn off all other switches
            var allSwitches = document.querySelectorAll('.custom-control-input.selectallmaster');
            allSwitches.forEach(function(switchElem) {
                if (switchElem.id !== 'customSwitch' + branchId) {
                    switchElem.checked = false;
                }
            });

            // Update session and checkbox state
            if (document.getElementById('customSwitch' + branchId).checked) {
                window.location.href = '{{ route('set-selected-branch') }}?branch=' + branchId;
            } else {
                window.location.href = '{{ route('set-selected-branch') }}';
            }

            // Store the selected branch in local storage
            function storeSelectedBranch(branchId) {
                localStorage.setItem('selectedBranch', branchId);
            }

            // Retrieve the selected branch from local storage
            function getSelectedBranch() {
                return localStorage.getItem('selectedBranch');
            }

            // Store the selected branch
            storeSelectedBranch(branchId);

            // Refresh the page
            // location.reload();

            function updateDashboardText(branchId) {
                var selectedBranch = document.getElementById('customSwitch' + branchId);
                var dashboardText = document.getElementById('dashboardText');

                if (selectedBranch.checked) {
                    var companyName = selectedBranch.getAttribute('data-company-name');
                    var branchName = selectedBranch.getAttribute('data-branch-name');
                    dashboardText.textContent = companyName + ' | ' + branchName;
                } else {
                    dashboardText.textContent = 'Dashboard';
                }
            }
        }

        $(document).ready(function(e) {


            $('#image').change(function() {

                let reader = new FileReader();

                reader.onload = (e) => {

                    $('#preview-image-before-upload').attr('src', e.target.result);
                }

                reader.readAsDataURL(this.files[0]);

            });
        });
    </script>

    <script>
        $(document).ready(function() {
            @if ($user->terms_accept === 0)
                $('#termsModal').modal('show');
            @endif
        });
    </script>
    <script>
        $(document).ready(function() {
            $('#acceptTermsButton').click(function() {
                // Send an AJAX request to update terms_accept status
                $.post("{{ route('update.terms.accept') }}", function(data) {
                    // If the update is successful, hide the modal
                    $('#termsModal').modal('hide');
                });
            });
        });
    </script>

{{-- <script>


    var options = {
    series: [{
        name: "2018",
        type: "line",
        data: [20, 34, 27, 59, 37, 26, 38, 25]
    }, {
        name: "2019",
        data: [10, 24, 17, 49, 27, 16, 28, 15],
        type: "area"
    }],
    chart: {
        height: 260,
        type: "line",
        toolbar: {
            show: false
        },
        zoom: {
            enabled: false
        }
    },
    colors: ["#45cb85", "#3b5de7"],
    dataLabels: {
        enabled: false
    },
    stroke: {
        curve: "smooth",
        width: "3",
        dashArray: [4, 0]
    },
    markers: {
        size: 3
    },
    xaxis: {
        categories: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug"],
        title: {
            text: "Month"
        }
    },
    fill: {
        type: "solid",
        opacity: [1, 0.1]
    },
    legend: {
        position: "top",
        horizontalAlign: "right"
    }
};

var chart = new ApexCharts(document.querySelector("#line-chart"), options);
chart.render();



    </script> --}}
    <script>
        var options = {
series: [],
chart: {
    height: 260,
    type: "line",
    toolbar: {
        show: false
    },
    zoom: {
        enabled: false
    }
},
colors: ["#45cb85", "#3b5de7"],
dataLabels: {
    enabled: false
},
stroke: {
    curve: "smooth",
    width: "3",
    dashArray: [4, 0]
},
markers: {
    size: 3
},
xaxis: {
    categories: [],
    title: {
        text: "Month"
    }
},
fill: {
    type: "solid",
    opacity: [1, 0.1]
},
legend: {
    position: "top",
    horizontalAlign: "right"
}
};

// Populate series dynamically from PHP data
var seriesData = [];
@foreach ($chartData as $dataPoint)
seriesData.push({
    name: "{{ $dataPoint->month }}",
    data: [{{ $dataPoint->total_amount }}],
    type: "line"
});
@endforeach
options.series = seriesData;

// Populate x-axis categories dynamically from PHP data
var categoriesData = [];
@foreach ($chartData as $dataPoint)
categoriesData.push("{{ $dataPoint->month }}");
@endforeach
options.xaxis.categories = categoriesData;

var chart = new ApexCharts(document.querySelector("#line-chart"), options);
chart.render();

    </script>
<script>
// Your JavaScript code
var options = {
    'series': [
        {
            'name': 'Total Amount',
            'data': <?php echo json_encode($seriesData); ?>
        }
    ],
    'chart': {
        'type': 'bar',
        'height': 260,
        'stacked': true,
        'toolbar': {
            'show': false
        },
        'zoom': {
            'enabled': true
        }
    },
    'plotOptions': {
        'bar': {
            'horizontal': false,
            'columnWidth': '5%',
            'endingShape': 'rounded'
        }
    },
    'dataLabels': {
        'enabled': false
    },
    'xaxis': {
        'categories': <?php echo json_encode($categories); ?>
    },
    'colors': ["#3b5de7"],
    'fill': {
        'opacity': 1
    }
};

var chart = new ApexCharts(document.querySelector("#column-chart"), options);
chart.render();
</script>
<script>
var options = {
    series: [],
    chart: {
        height: 260,
        type: "line",
        toolbar: {
            show: false
        },
        zoom: {
            enabled: false
        }
    },
    colors: ["#45cb85", "#3b5de7"],
    dataLabels: {
        enabled: false
    },
    stroke: {
        curve: "smooth",
        width: "3",
        dashArray: [4, 0]
    },
    markers: {
        size: 3
    },
    xaxis: {
        categories: [],
        title: {
            text: "Day"
        }
    },
    fill: {
        type: "solid",
        opacity: [1, 0.1]
    },
    legend: {
        position: "top",
        horizontalAlign: "right"
    }
};

// Populate series dynamically from PHP data
var seriesData = [];
@foreach ($chartDataDayWise as $dataPoint)
    seriesData.push({
        name: "{{ $dataPoint->day }}",
        data: [{{ $dataPoint->total_amount }}],
        type: "line"
    });
@endforeach
options.series = seriesData;

// Populate x-axis categories dynamically from PHP data
var categoriesData = [];
@foreach ($chartDataDayWise as $dataPoint)
    categoriesData.push("{{ $dataPoint->day }}");
@endforeach
options.xaxis.categories = categoriesData;

var chart = new ApexCharts(document.querySelector("#line-chart-day-wise"), options);
chart.render();
</script>
<script>
// Your JavaScript code
var options = {
    'series': [
        {
            'name': 'Total Amount',
            'data': <?php echo json_encode($chartDataLast7Days->pluck('total_amount')->toArray()); ?>
        }
    ],
    'chart': {
        'type': 'bar',
        'height': 260,
        'stacked': true,
        'toolbar': {
            'show': false
        },
        'zoom': {
            'enabled': true
        }
    },
    'plotOptions': {
        'bar': {
            'horizontal': false,
            'columnWidth': '5%',
            'endingShape': 'rounded'
        }
    },
    'dataLabels': {
        'enabled': false
    },
    'xaxis': {
        'categories': <?php echo json_encode($chartDataLast7Days->pluck('day')->toArray()); ?>
    },
    'colors': ["#3b5de7"],
    'fill': {
        'opacity': 1
    }
};

var chart = new ApexCharts(document.querySelector("#column-chart-7-wise"), options);
chart.render();
</script>




<script>
        var options = {
series: [],
chart: {
    height: 260,
    type: "line",
    toolbar: {
        show: false
    },
    zoom: {
        enabled: false
    }
},
colors: ["#45cb85", "#3b5de7"],
dataLabels: {
    enabled: false
},
stroke: {
    curve: "smooth",
    width: "3",
    dashArray: [4, 0]
},
markers: {
    size: 3
},
xaxis: {
    categories: [],
    title: {
        text: "Month"
    }
},
fill: {
    type: "solid",
    opacity: [1, 0.1]
},
legend: {
    position: "top",
    horizontalAlign: "right"
}
};

// Populate series dynamically from PHP data
var seriesData = [];
@foreach ($chartDataPurchase as $dataPoint)
seriesData.push({
    name: "{{ $dataPoint->month }}",
    data: [{{ $dataPoint->total_amount }}],
    type: "line"
});
@endforeach
options.series = seriesData;

// Populate x-axis categories dynamically from PHP data
var categoriesData = [];
@foreach ($chartDataPurchase as $dataPoint)
categoriesData.push("{{ $dataPoint->month }}");
@endforeach
options.xaxis.categories = categoriesData;

var chart = new ApexCharts(document.querySelector("#line-chart-purchase"), options);
chart.render();

    </script>
<script>
// Your JavaScript code
var options = {
    'series': [
        {
            'name': 'Total Amount',
            'data': <?php echo json_encode($seriesDataPurchase); ?>
        }
    ],
    'chart': {
        'type': 'bar',
        'height': 260,
        'stacked': true,
        'toolbar': {
            'show': false
        },
        'zoom': {
            'enabled': true
        }
    },
    'plotOptions': {
        'bar': {
            'horizontal': false,
            'columnWidth': '5%',
            'endingShape': 'rounded'
        }
    },
    'dataLabels': {
        'enabled': false
    },
    'xaxis': {
        'categories': <?php echo json_encode($categoriesPurchase); ?>
    },
    'colors': ["#3b5de7"],
    'fill': {
        'opacity': 1
    }
};

var chart = new ApexCharts(document.querySelector("#column-chart-purchase"), options);
chart.render();
</script>
@endsection
