@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Item Group Master</h6>
                            </div>
                        </div>
                        <form action="{{ route('software.item_groups.store') }}" class="outer-repeater" method="post">
                            @csrf
                            <div data-repeater-list="outer-group" class="outer">
                                <div data-repeater-item class="outer">

                                    <div class="row">
                                        <div class="inner-repeater mb-12">
                                            <div data-repeater-list="inner-group" class="inner form-group">
                                                <label>Item Group :</label>
                                                @if(old('name'))
                                                    @foreach(old('name') as $index => $name)
                                                        <div data-repeater-item class="inner mb-3 row">
                                                            <div class="col-md-8 col-8">
                                                                <input name="name[]" value="{{ $name }}" type="text"
                                                                    class="inner form-control" placeholder="Enter Item Group" />
                                                                @error('name.' . $index)
                                                                    <div class="text-danger">{{ $message }}</div>
                                                                @enderror
                                                            </div>
                                                            <div class="col-md-4 col-4">
                                                                <input data-repeater-delete type="button"
                                                                    class="btn btn-cust1 btn-block inner" value="Delete"
                                                                    onclick="deleteItem(this)" />
                                                            </div>
                                                        </div>
                                                    @endforeach
                                                @else
                                                    <div data-repeater-item class="inner mb-3 row">
                                                        <div class="col-md-8 col-8">
                                                            <input name="name[]" type="text"
                                                                class="inner form-control" placeholder="Enter Item Group" />
                                                            @error('name.0')
                                                                <div class="text-danger">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                        <div class="col-md-4 col-4">
                                                            <input data-repeater-delete type="button"
                                                                class="btn btn-cust1 btn-block inner" value="Delete"
                                                                onclick="deleteItem(this)" />
                                                        </div>
                                                    </div>
                                                @endif
                                            </div>
                                            <input data-repeater-create type="button" class="btn btn-primary inner"
                                                value="Add Item Group" onclick="addItem(this)" />
                                            @error('name.*')
                                                <div class="text-danger">{{ $message }}</div>
                                            @enderror
                                        </div>
                                    </div>

                                    <button class="btn btn-cust1 float-right" data-toggle="modal" data-target=""
                                        type="submit">Save Item Group</button>

                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->

    <div class="modal fade bs-example-modal-center1" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-check checkp "></i>
                            <h4 class="card-title font-size-18">Successfully Recorded
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->


    <div class="modal fade bs-example-modal-center2" tabindex="-2" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-times crossp "></i>
                            <h4 class="card-title font-size-18">Submission Failed
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->

    <!-- end row -->
    <script>
        // Function to clone and add a new input field
        function addItem(button) {
        var innerRepeater = button.closest('.inner-repeater');
        var newItem = innerRepeater.querySelector('[data-repeater-item]').cloneNode(true);
        innerRepeater.querySelector('[data-repeater-list="inner-group"]').appendChild(newItem);

        // Clear cloned field value and error message
        var clonedInput = newItem.querySelector('input[name="name[]"]');
        clonedInput.value = '';
        var clonedError = newItem.querySelector('.text-danger');
        if (clonedError) {
            clonedError.textContent = '';
        }
    }

        // Function to delete an input field
        function deleteItem(button) {
            var repeaterItem = button.closest('[data-repeater-item]');
            repeaterItem.remove();
        }
    </script>
@endsection
