@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="row">
                <div class="col-md-6">
                    <h6 class="card-title mb-4 titlcust">View Delivery Note</h6>
                </div>
                <div class="col-md-6">
                    <a href="">
                        <button class="btn btn-outline-primary float-right cust-btn1" onclick="printPageArea('printableArea')"
                            type="submit">Print Document
                        </button>
                    </a>
                    <a href="">
                        <button class="btn btn-outline-primary float-right" type="submit">Back
                        </button>
                    </a>
                </div>
            </div>

            <div class="card" id="printableArea">
                <div class="card-body">

                    <h6 class="card-title mb-1 text-center font-size-20">Delivery Note</h6>
                    <br>


                    @if (!empty(($companyLogo = auth()->user()->company_logo)))
                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                        <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                            alt="logo" width="270px">
                        </div>
                    @else
                    <div class="col-md-12 d-flex align-items-center justify-content-center mb-3">
                        <img src="{{ asset('assets/images/acp-logo.svg') }}" class="img-fluid" alt="logo"
                            width="270px">
                    </div>
                    @endif

                    <div class="row">
                        <div class="col-md-9 pt-2" style="border-top: solid;border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Name: </strong> {{ $company->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Name: </strong> {{ session()->get('branch')->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Address</strong> {{ session()->get('branch')->address }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Country</strong> {{ $company->country }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company CR Number</strong> {{ $company->cr_number }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company VAT Number</strong> {{ $company->vat_number }}</p>
                        </div>
                        <div class="col-md-3 pt-2" style="border-top: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Date : </strong> {{ $deliveryNote[0]->date }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Delivery Note # : </strong> {{ $deliveryNote[0]->invoice_no }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Mode/Term of Payment : </strong> {{ $deliveryNote[0]->term_of_payment }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO Number(Supplier) : </strong> {{ $deliveryNote[0]->lpo_no }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Delivery Note Number : </strong> {{ $deliveryNote[0]->po_no ?? '' }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO(DUE DAYS) : </strong> {{ $deliveryNote[0]->lpo_days }}</p>
                        </div>
                        <div class="col-md-12" style="border-left: solid;border-right: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Client; </strong> </p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Account Name : </strong> {{ $deliveryNote[0]->account->name_of_organisation ?? ($deliveryNote[0]->account->account_name ?? $deliveryNote[0]->account->first_name . ' ' . $deliveryNote[0]->account->last_name) }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Email :</strong> {{ $deliveryNote[0]->account->email ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Contact Person Name : </strong>{{ $deliveryNote[0]->account->contact_person_name ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Contact Number : </strong>{{ $deliveryNote[0]->account->mobile ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>VAT Number : </strong>{{ $deliveryNote[0]->account->vat_number ?? 'No Record Found' }}</p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="table-responsive mb-0 pb-0" >
                            <table class="table table-striped table-bordered dt-responsive nowrap mb-0" style="border-bottom: solid;border-left: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                                <thead >
                                    <tr style="background-color: black;color:white;border-color: black">
                                        <th style="border: none">Item Name</th>
                                        <th style="border: none">Item Description</th>
                                        <th style="border: none">QTY</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body" >
                                    @foreach ($deliveryNote as $key=>$dn)

                                   <tr>
                                        <td class="border border-dark">{{ $dn->item->name ?? '' }}</td>
                                        <td class="border border-dark">{{ $dn->item_description }}</td>
                                        <td class="border border-dark">{{ $dn->quantity }}</td>
                                   </tr>
                                   @endforeach

                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-8 pt-2" style="border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0">{!! session()->get('branch')->payment_details !!}</p>
                        </div>
                        <div class="col-md-2 pt-2" style="border-bottom: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-color: black;padding: 5px;margin:0;"><strong>Quantity Total </strong></p>
                        </div>
                        <div class="col-md-2 pt-2" style="border-bottom: solid;border-right: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-color: black;padding: 5px;margin:0;">{{ $deliveryNote[0]->total_quantity }}</p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end" style="border-bottom: solid; border-left: solid; border-color: black; padding: 0; height: 150px;">
                            <p class="text-dark font-weight-bold text-left" style="padding: 5px; margin: 0;"><strong>Client Signature & Stamp</strong></p>
                        </div>


                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end" style="border-bottom: solid;border-right: solid;border-color: black;padding: 0;height: 150px;">
                            <p class="text-dark font-weight-bold mt-5 text-right" style="padding: 5px;margin:0"><strong>{{ $company->name }}</strong></p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12 pt-2 d-flex flex-column justify-content-center alien-item-center" >
                            <p class="text-dark font-weight-bold text-center" style="padding: 5px; margin: 0;"><strong>Generated by Ledgematic</strong></p>
                        </div>
                    </div>

                    {{-- <div class="row border1">
                        @if (!empty(($companyLogo = auth()->user()->company_logo)))
                            <div class="col-md-2 d-flex align-items-center justify-content-center">
                                <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                                    alt="logo" width="180px">
                            </div>
                        @else
                            <div class="col-md-2 d-flex align-items-center justify-content-center">
                                <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                    width="180px">
                            </div>
                        @endif
                        <div class="col-md-6">
                            <div class="row border1">
                                <div class="pading1">
                                    <div class="col-md-12 ">
                                        <span>{{ $company->name }}</span>
                                    </div>
                                    <div class="col-md-12 ">
                                        <span>{{ $company->country }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>Branch Name :</label>
                                        <span>{{ session()->get('branch')->name }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>Branch Address :</label>
                                        <span>{{ session()->get('branch')->address }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>Cr Number :</label>
                                        <span>{{ $company->cr_number }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>VAT Number :</label>
                                        <span>{{ $company->vat_number }}</span>
                                    </div>

                                </div>
                            </div>

                            <div class="row border1">
                                <div class="pading1">
                                    <div class="col-md-12">
                                        <h5>Buyer</h5>
                                    </div>
                                    @if ($deliveryNote[0]->buyer != null)
                                        <div class="col-md-12">
                                            <span>
                                                @if ($deliveryNote[0]->account_type == 'App\Customer' || $deliveryNote[0]->account_type == 'App\Supplier')
                                                    {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->name_of_organisation }}
                                                @elseif ($deliveryNote[0]->account_type == 'App\StaffAndSalesman')
                                                    {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->first_name . ' ' . $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->last_name }}
                                                @else
                                                    {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->account_name }}
                                                @endIf
                                            </span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Email :</label>
                                            <span>{{ $deliveryNote[0]->buyer->email ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Contact Person Name :</label>
                                            <span>{{ $deliveryNote[0]->buyer->name ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Contact Number :</label>
                                            <span>{{ $deliveryNote[0]->buyer->phone ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>VAT Number :</label>
                                            <span>{{ $deliveryNote[0]->buyer->vat_number ?? 'No Record Found' }}</span>
                                        </div>
                                    @else
                                        <span>
                                            @if ($deliveryNote[0]->account_type == 'App\Customer' || $deliveryNote[0]->account_type == 'App\Supplier')
                                                {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->name_of_organisation }}
                                            @elseif ($deliveryNote[0]->account_type == 'App\StaffAndSalesman')
                                                {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->first_name . ' ' . $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->last_name }}
                                            @else
                                                {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->account_name }}
                                            @endIf
                                        </span>
                                </div>
                                <div class="col-md-12">
                                    <label>Email :</label>
                                    <span>
                                        @if ($deliveryNote[0]->account_type == 'App\Customer' || $deliveryNote[0]->account_type == 'App\Supplier')
                                            {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->email }}
                                        @else
                                            No Record Exists
                                        @endIf
                                    </span>
                                </div>
                                <div class="col-md-12">
                                    <label>Contact Person Name :</label>
                                    <span>
                                        @if ($deliveryNote[0]->account_type == 'App\Customer' || $deliveryNote[0]->account_type == 'App\Supplier')
                                            {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->contact_person_name }}
                                        @else
                                            No Record Exists
                                        @endIf
                                    </span>
                                </div>
                                <div class="col-md-12">
                                    <label>Contact Number :</label>
                                    <span>
                                        @if ($deliveryNote[0]->account_type == 'App\Customer' || $deliveryNote[0]->account_type == 'App\Supplier')
                                            {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->mobile }}
                                        @else
                                            No Record Exists
                                        @endIf
                                    </span>
                                </div>
                                <div class="col-md-12">
                                    <label>VAT Number :</label>
                                    <span>
                                        @if ($deliveryNote[0]->account_type == 'App\Customer' || $deliveryNote[0]->account_type == 'App\Supplier')
                                            {{ $deliveryNote[0]->account_type::find($deliveryNote[0]->account_id)->vat_number }}
                                        @else
                                            No Record Exists
                                        @endIf
                                    </span>
                                </div>
                                @endIf
                            </div>
                        </div>
                    </div> --}}

                    {{-- <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table class="table table-bordered dt-responsive nowrap">
                            <tr>
                                <td>
                                    <table class="table table-bordered dt-responsive nowrap">
                                        <tr>
                                            <td>
                                                @if (!empty(($companyLogo = auth()->user()->company_logo)))
                                                <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                    <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                                                        alt="logo" width="700px">
                                                    </div>
                                                @else
                                                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                        <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                                            width="700px">
                                                    </div>
                                                @endif
                                            </td>
                                            <td colspan="2">
                                                <div class="row">
                                                    <div class="col-md-12 ">
                                                        <label>Company Name :</label>
                                                        <span>{{ $company->name }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Branch Name :</label>
                                                        <span>{{ session()->get('branch')->name }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Branch Address :</label>
                                                        <span>{{ session()->get('branch')->address }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company Country :</label>
                                                        <span>{{ $company->country }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company CR Number :</label>
                                                        <span>{{ $company->cr_number }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company Vat Number :</label>
                                                        <span>{{ $company->vat_number }}</span>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>

                                            </td>
                                            <td>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <h5>Buyer</h5>
                                                    </div>

                                                        <div class="col-md-12">
                                                            <label>Account Name :</label>
                                                            <span>{{ $deliveryNote[0]->account->name_of_organisation ?? ($deliveryNote[0]->account->account_name ?? $deliveryNote[0]->account->first_name . ' ' . $deliveryNote[0]->account->last_name) }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Email :</label>
                                                            <span>{{ $deliveryNote[0]->account->email ?? 'No Record Found' }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Contact Person Name :</label>
                                                            <span>{{ $deliveryNote[0]->account->contact_person_name ?? 'No Record Found' }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Contact Number :</label>
                                                            <span>{{ $deliveryNote[0]->account->mobile ?? 'No Record Found' }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>VAT Number :</label>
                                                            <span>{{ $deliveryNote[0]->account->vat_number ?? 'No Record Found' }}</span>
                                                        </div>
                                                </div>
                                            </td>


                                        </tr>
                                    </table>
                                </td>
                                <td>
                                    <table class="table table-bordered dt-responsive nowrap">
                                        <tr>
                                            <td>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <label>Purchase Invoice # :</label>
                                                        <span>{{ $deliveryNote[0]->invoice_no }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Mode/Term of Payment :</label>
                                                        <span>{{ $deliveryNote[0]->term_of_payment }}</span>
                                                    </div>

                                                    <div class="col-md-12">
                                                        <label>Date :</label>
                                                        <span>{{ $deliveryNote[0]->date }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>LPO Number(Supplier) :</label>
                                                        <span>{{ $deliveryNote[0]->lpo_no }}</span>
                                                    </div>

                                                    <div class="col-md-12">
                                                        <label>Purchase Order Number :</label>
                                                        <span>{{ $deliveryNote[0]->po_no ?? '' }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>LPO(DUE DAYS) :</label>
                                                        <span>{{ $deliveryNote[0]->lpo_days }}</span>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>

                                </table>
                                </td>
                            </tr>
                        </table>
                    </div> --}}
{{--
                    <br>
                    <div class="col-md-4">
                        <div class="row border1">
                            <div class="pading1">
                                <div class="col-md-12">
                                    <label>Delivery Note #:</label>
                                    <span>{{ $deliveryNote[0]->do_no }}</span>
                                </div>

                                <div class="col-md-12">
                                    <label>Date :</label>
                                    <span>{{ $deliveryNote[0]->date }}</span>
                                </div>

                                <div class="col-md-12">
                                    <label>Quotation #:</label>
                                    <span>{{ $deliveryNote[0]->quotation_no ?? '' }}</span>
                                </div>
                            </div>
                        </div>
                    </div>
                    </div>

                <br>


                <div class="row">

                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>S No.</th>
                                    <th>Item Name</th>
                                    <th>Item Description</th>
                                    <th>Quantity</th>
                                </tr>
                            </thead>

                            <tbody id="table-body">
                                @forelse ($deliveryNote as $key=>$dn)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>
                                            <p>{{ $dn->item->name }}</p>
                                        </td>
                                        <td>
                                            <p>{{ $dn->item_description }}</p>
                                        </td>
                                        <td>
                                            <p>{{ $dn->quantity }}</p>
                                        </td>
                                    </tr>
                                @empty
                                @endforelse
                                <tr>
                                    <td></td>
                                    <td>Grand Total</td>
                                    <td></td>
                                    <td>{{ $deliveryNote[0]->total_quantity }}</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <br>


                <div class="table-responsive mb-0" data-pattern="priority-columns">
                    <table class="table table-bordered dt-responsive nowrap max-width">
                        <tr>
                            <td>
                                <label>Term & Conditions</label>
                                <p class="">
                                <p>{{ $tnc->description ?? '' }}</p>
                                </p>
                            </td>
                            <td>
                                <label>Narrations</label>
                                <p>{{ $deliveryNote[0]->narrations }}</p>
                            </td>
                        </tr>
                    </table>
                </div> --}}

            </div>
        </div>
    </div>
    </div>
    </div>
    <!-- end row -->

    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection
