@extends('layouts.crusher')
@section('content')





    <div class="row">
        <div class="col-md-12">
            <div class="row mt-4 mb-1">
                <div class="col-md-6">
                    <h6 class="card-title mb-4 titlcust">View Payment Voucher</h6>
                </div>
                <div class="col-md-6">
                    <a href="">
                        <button class="btn btn-outline-primary float-right cust-btn1" onclick="printPageArea('printableArea')"
                            type="submit">Print Document
                        </button>
                    </a>
                    <a href="">
                        <button class="btn btn-outline-primary float-right" type="submit">Back
                        </button>
                    </a>
                </div>
            </div>
            <div class="card" id="printableArea">
                <div class="card-body">

                    <h6 class="card-title mb-1 text-center font-size-20">Payment Voucher</h6>
                    <br>


                    @if (!empty(($companyLogo = auth()->user()->company_logo)))
                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                        <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                            alt="logo" width="270px">
                        </div>
                    @else
                    <div class="col-md-12 d-flex align-items-center justify-content-center mb-3">
                        <img src="{{ asset('assets/images/acp-logo.svg') }}" class="img-fluid" alt="logo"
                            width="270px">
                    </div>
                    @endif

                    <div class="row">
                        <div class="col-md-9 pt-2" style="border-top: solid;border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Name: </strong> {{ $company->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Name: </strong> {{ session()->get('branch')->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Address</strong> {{ session()->get('branch')->address }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Country</strong> {{ $company->country }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company CR Number</strong> {{ $company->cr_number }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company VAT Number</strong> {{ $company->vat_number }}</p>
                        </div>
                        <div class="col-md-3 pt-2" style="border-top: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Date : </strong> {{ $paymentVoucher[0]->date }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Payment Voucher # : </strong> {{ $paymentVoucher[0]->invoice_no }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Mode/Term of Payment : </strong> {{ $paymentVoucher[0]->term_of_payment }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO Number(Supplier) : </strong> {{ $paymentVoucher[0]->lpo_no }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Payment Voucher Number : </strong> {{ $paymentVoucher[0]->po_no ?? '' }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO(DUE DAYS) : </strong> {{ $paymentVoucher[0]->lpo_days }}</p>
                        </div>
                        {{-- <div class="col-md-12" style="border-left: solid;border-right: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Client; </strong> </p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Account Name : </strong> {{ $paymentVoucher[0]->account->name_of_organisation ?? ($paymentVoucher[0]->account->account_name ?? $paymentVoucher[0]->account->first_name . ' ' . $paymentVoucher[0]->account->last_name) }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Email :</strong> {{ $paymentVoucher[0]->account->email ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Contact Person Name : </strong>{{ $paymentVoucher[0]->account->contact_person_name ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Contact Number : </strong>{{ $paymentVoucher[0]->account->mobile ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>VAT Number : </strong>{{ $paymentVoucher[0]->account->vat_number ?? 'No Record Found' }}</p>
                        </div> --}}
                    </div>
                    <div class="row">
                        <div class="table-responsive mb-0 pb-0" >
                            <table class="table table-striped table-bordered dt-responsive nowrap mb-0" style="border-bottom: solid;border-left: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                                <thead>
                                    <tr style="background-color: black;color:white;border-color: black">
                                        <th style="border: none">S No.</th>
                                        <th style="border: none">Account Name</th>
                                        <th style="border: none">Amount</th>
                                        <th style="border: none">BillWise/OnAccount</th>
                                        <th style="border: none">Select Invoice</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body" >
                                    @php
                                        $totalAmount = 0;
                                    @endphp
                                    @forelse ($paymentVoucher as $rv)
                                    @forelse ($rv->expense as $key=>$expense)
                                        <tr>
                                                <td class="border border-dark">{{ $key + 1 }}</td>
                                                <td class="border border-dark">{{ $expense->account->name_of_organisation ?? $expense->account->account_name }}</td>
                                                <td class="border border-dark">{{ number_format($expense->amount, session('branch')->currency_decimal) }}</td>
                                                <td class="border border-dark">{{ $expense->bill_wise_id }}</td>
                                                <td class="border border-dark">{{ $expense->inovice_id }}</td>
                                        </tr>
                                        @php
                                            $totalAmount += $expense->amount;
                                        @endphp
                                   @empty
                                   @endforelse
                                   @empty
                                   @endforelse
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-8 pt-2" style="border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0">{!! session()->get('branch')->payment_details !!}</p>
                        </div>
                        <div class="col-md-2" style="border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-right: solid;border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Net Total </strong></p>
                        </div>
                        <div class="col-md-2" style="border-right: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;">{{ number_format($totalAmount, session('branch')->currency_decimal) }}</p>
                        </div>
                        <div class="col-md-8 pt-2" style="border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            {{-- <p class="text-dark font-weight-bold" style="padding: 5px;margin:0">Advance Corporate Professionals & Businesses L.L.C.</p> --}}
                        </div>
                        <div class="col-md-4 pt-2" style="border-right: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Amount in Words: </strong><span>{{ $paymentVoucher[0]->AmountInWords }}</span></p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end" style="border-bottom: solid; border-left: solid; border-color: black; padding: 0; height: 150px;">
                            <p class="text-dark font-weight-bold text-left" style="padding: 5px; margin: 0;"><strong>Client Signature & Stamp</strong></p>
                        </div>


                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end" style="border-bottom: solid;border-right: solid;border-color: black;padding: 0;height: 150px;">
                            <p class="text-dark font-weight-bold mt-5 text-right" style="padding: 5px;margin:0"><strong>{{ $company->name }}</strong></p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12 pt-2 d-flex flex-column justify-content-center alien-item-center" >
                            <p class="text-dark font-weight-bold text-center" style="padding: 5px; margin: 0;"><strong>Generated by Ledgematic</strong></p>
                        </div>
                    </div>

                    {{-- <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table class="table table-bordered dt-responsive nowrap">
                            <tr>
                                <td>
                                    <table class="table table-bordered dt-responsive nowrap">
                                        <tr>
                                            <td>
                                                @if (!empty(($companyLogo = auth()->user()->company_logo)))
                                                <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                    <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                                                        alt="logo" width="700px">
                                                    </div>
                                                @else
                                                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                        <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                                            width="700px">
                                                    </div>
                                                @endif
                                            </td>
                                            <td colspan="2">
                                                <div class="row">
                                                    <div class="col-md-12 ">
                                                        <label>Company Name :</label>
                                                        <span>{{ $company->name }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Branch Name :</label>
                                                        <span>{{ session()->get('branch')->name }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Branch Address :</label>
                                                        <span>{{ session()->get('branch')->address }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company Country :</label>
                                                        <span>{{ $company->country }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company CR Number :</label>
                                                        <span>{{ $company->cr_number }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company Vat Number :</label>
                                                        <span>{{ $company->vat_number }}</span>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>

                                            </td>
                                            <td>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <h5>Buyer</h5>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                    </table>
                                </td>
                                <td>
                                    <table class="table table-bordered dt-responsive nowrap">
                                        <tr>
                                            <td>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <label>Purchase Invoice # :</label>
                                                        <span>{{ $paymentVoucher[0]->invoice_no }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Mode/Term of Payment :</label>
                                                        <span>{{ $paymentVoucher[0]->term_of_payment }}</span>
                                                    </div>

                                                    <div class="col-md-12">
                                                        <label>Date :</label>
                                                        <span>{{ $paymentVoucher[0]->date }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>LPO Number(Supplier) :</label>
                                                        <span>{{ $paymentVoucher[0]->lpo_no }}</span>
                                                    </div>

                                                    <div class="col-md-12">
                                                        <label>Purchase Order Number :</label>
                                                        <span>{{ $paymentVoucher[0]->po_no ?? '' }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>LPO(DUE DAYS) :</label>
                                                        <span>{{ $paymentVoucher[0]->lpo_days }}</span>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>

                                </table>
                                </td>
                            </tr>
                        </table>
                    </div>

                    <br>

                    <div class="row">
                        <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table class="table table-bordered dt-responsive nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>S No.</th>
                                        <th>Account Name</th>
                                        <th>Amount</th>
                                        <th>BillWise/OnAccount</th>
                                        <th>Select Invoice</th>
                                    </tr>
                                </thead>

                                <tbody id="table-body">
                                    @forelse ($paymentVoucher as $rv)
                                        @forelse ($rv->expense as $key=>$expense)
                                            <tr>
                                                <td>{{ $key + 1 }}</td>
                                                <td>
                                                    <p>
                                                        @isset($expense->account)
                                                            {{ $expense->account->name_of_organisation ?? $expense->account->account_name }}
                                                        @endisset
                                                    </p>

                                                </td>
                                                <td>
                                                    <p>{{ $expense->amount }}</p>
                                                </td>
                                                <td>
                                                    <p>{{ $expense->bill_wise_id }}</p>
                                                </td>
                                                <td>
                                                    <p>{{ $expense->inovice_id }}</p>
                                                </td>
                                            </tr>
                                        @empty
                                        @endforelse
                                    @empty
                                    @endforelse
                                    <tr>
                                        <td></td>
                                        <td>Grand Total</td>
                                        <td id="grand-total"></td>
                                        <td></td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td></td>
                                        <td>Ladjure</td>
                                        <td>{{ $paymentVoucher[0]->expense->sum('expense_amount') }}</td>
                                        <td></td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td></td>
                                        <td>Total Amount</td>
                                        <td id="total-amount">
                                            {{ $paymentVoucher[0]->expense->sum('expense_amount') + $paymentVoucher[0]->expense->sum('amount') }}
                                        </td>
                                        <td></td>
                                        <td></td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>



                    <br>
                    <div class="row">
                        <div class="col-md-12">
                            <label for="name">Amount in Words:</label>
                            <span id="total_net_amount_words"></span>
                        </div>

                    </div>
                    </form> --}}


                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->


    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>

    <script>
        document.addEventListener("DOMContentLoaded", function() {
            // Initialize total amount
            let totalAmount = 0;
            let grandAmount = 0;

            // Extract receipt voucher data from Blade's inline PHP
            const paymentVoucher = @json($paymentVoucher);

            // Loop through receipt voucher expenses to calculate total amount
            paymentVoucher.forEach(function(rv) {
                rv.expense.forEach(function(expense) {
                    const amount = parseFloat(expense.amount);
                    const expenseAmount = parseFloat(expense.expense_amount);
                    grandAmount += amount;
                    totalAmount += amount;
                    totalAmount += expenseAmount;
                });
            });

            // Update the grand total element with the calculated total amount
            document.getElementById("grand-total").textContent = grandAmount.toFixed(2);

            // Convert total net amount to words and update the corresponding field
            var totalNetAmountWords = numberToWords(totalAmount.toFixed(
                {{ session()->get('branch')->currency_decimal }}));
            $('#total_net_amount_words').text(totalNetAmountWords);
        });
    </script>

@endsection
