<?php

namespace App\Http\Controllers\MainMenu;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Country;
use App\Location;
use App\ApprovalVoucher;
use App\JournalVoucher;
use App\LocationPermission;
use App\LocationPermissionTrack;
use App\PaymentVoucher;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\ReceiptVoucher;
use App\SaleInvoice;
use App\SaleInvoiceItem;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Illuminate\Support\Facades\Auth;

class SearchInvoiceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    public function search()
    {
        $user = Auth::user();
        if (!$user->can('view-edit-print-invoice-voucher-permission')) {
            abort(403, 'Unauthorized action.');
        }

        if(Auth::user()->hasRole('user')){
            $permission = LocationPermission::Where('user_id', Auth::user()->id)->get();

            $option = LocationPermissionTrack::Where('user_id', Auth::user()->id)->first();
            $permission_option = $option->permission_option;

            foreach ($permission as $perm) {
                $countries[] =  Country::Where('id', $perm->country_id)->first();
            }
            $countries = array_unique($countries);

            return view('user.main_menu.search_invoice', compact('countries', 'permission_option'));

        }
        else{
            $countries = Country::all();
            $permission_option = "all_countries_all_locations";
            return view('user.main_menu.search_invoice', compact('countries', 'permission_option'));
        }

    }

    public function search_result(Request $request){

        $user = Auth::user();
        if (!$user->can('view-edit-print-invoice-voucher-permission')) {
            abort(403, 'Unauthorized action.');
        }

        Utils::setLocation($request-> location);

        $search_voucher = $request->voucher;

        if ($search_voucher == "approval-vouchers") {
            $vouchers = ApprovalVoucher::where('location_id', $request->location)
                                        ->Where('invoice_no', $request->invoice_no)
                                        ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
        elseif ($search_voucher == "sales-invoices") {
            $vouchers = SaleInvoice::where('location_id', $request->location)
                                        ->Where('invoice_no', $request->invoice_no)
                                        ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
        elseif ($search_voucher == "purchase-invoices") {
            $vouchers = PurchaseInvoice::where('location_id', $request->location)
                                        ->Where('invoice_no', $request->invoice_no)
                                        ->get();
                                        $sales_items = [];
            foreach ($vouchers as $invoice) {
                foreach ($invoice->items as $item) {
                    $sales_items[] = SaleInvoiceItem::where('imei_serial_no', $item->imei_serial_no)->first();
                }

            }
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher','sales_items'));
        }
        elseif ($search_voucher == "sales-return-vouchers") {
            $vouchers = SalesReturnVoucher::where('location_id', $request->location)
                                            ->Where('invoice_no', $request->invoice_no)
                                            ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
        elseif ($search_voucher == "purchase-return-vouchers") {
            $vouchers = PurchaseReturnVoucher::where('location_id', $request->location)
                                                ->Where('invoice_no', $request->invoice_no)
                                                ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
        elseif ($search_voucher == "payment-vouchers") {
            $vouchers = PaymentVoucher::where('location_id', $request->location)
                                        ->Where('invoice_no', $request->invoice_no)
                                        ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
        elseif ($search_voucher == "receipt-vouchers") {
            $vouchers = ReceiptVoucher::where('location_id', $request->location)
                                        ->Where('invoice_no', $request->invoice_no)
                                        ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
        elseif ($search_voucher == "journal-vouchers") {
            $vouchers = JournalVoucher::where('location_id', $request->location)
                                        ->Where('voucher_no', $request->invoice_no)
                                        ->get();
            return view('user.main_menu.search_invoice_index', compact('vouchers', 'search_voucher'));
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
