<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class PaymentVoucher extends Model
{
    use SoftDeletes;
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'payment_vouchers';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'date',
        // 'account_id',
        'invoice_no',
        'payment_method',
        // 'total_amount',
        'gross_total',
        'net_total',
        'amount_in_words',
        'vat_amount',
        'tax_account_id',
        'narrations',
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    //'foreign_key', 'local_key'
    public function items()
    {
        return $this->hasMany('App\PaymentVoucherItem', 'payment_voucher_id', 'id');
    }

    public function account()
    {
        return $this->belongsTo('App\AccountMaster', 'account_id', 'id');
    }
}
