<?php

namespace App\Services;
use Illuminate\Http\Request;
use App\ClassOfAccount;
use App\Customer;
use App\Supplier;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminPurchaesInvoice;
use App\AdminSalesInvoice;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense;
use App\AdminJournalVoucher;
use App\StaffAndSalesman;
use App\CreditNote;
use App\DebitNote;
use Illuminate\Support\Facades\DB;

class AllAccountsObWithTransactionService
{

    public function AllAccountsCreateOpeningBalanceWithTransactionAmountsService($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $ClassOfAccount = ClassOfAccount::get();

        // from_date to to_date - date range data

        $customers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('date_of_joining', '>=', $from_date . ' 00:00:00')
            ->where('date_of_joining', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // dd($allAccounts);

        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($account->type === 'Debit' || $account->type === 'debit') {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif ($account->type === 'Credit' || $account->type === 'credit') {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_purchase_amount_with_cf');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name)
                    ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','cash')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name)
                    ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','bank')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name)
                ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','bank')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name)
                ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','cash')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;
            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;

            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }
            // dd($accountDetails);

            // currentYearFirstDate to oneDayPreviousDate - date range data

            $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
                ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

            $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
                ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

            $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
                ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

            $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
                ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

            $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
                ->where('date_of_joining', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date_of_joining', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
                ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
                ->get();

            $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

            // dd($opAllAccounts);

            $opAccountDetails = [];

            // currentYearFirstDate to oneDayPreviousDate - date range data

            foreach ($opAllAccounts as $opAccount) {
                $opDebitOBalance = 0;
                $opCreditOBalance = 0;
                $opCreateDebitOpeningBalance = 0;
                $opCreateCreditOpeningBalance = 0;
                $debitAllAccountsDate = 0;
                $creditAllAccountsDate = 0;

                if ($opAccount->type === 'Debit' || $opAccount->type === 'debit') {
                    $debitAllAccountsDate = $opAccount->date;
                    $opCreateDebitOpeningBalance = $opAccount->opening_balance;

                } elseif ($opAccount->type === 'Credit' || $opAccount->type === 'credit') {
                    $creditAllAccountsDate = $opAccount->date;
                    $opCreateCreditOpeningBalance = $opAccount->opening_balance;

                }

                // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

                $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum('total_purchase_amount_with_cf');

                $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum('total_net_amount');

                $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where(function($query) use ($opAccount) {
                    $query->where('account_name', $opAccount->account_name)
                        ->orWhere('bank_name', $opAccount->account_name);
                    })
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('payment_method','cash')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum('amount');
                $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where(function($query) use ($opAccount) {
                    $query->where('account_name', $opAccount->account_name)
                        ->orWhere('bank_name', $opAccount->account_name);
                    })
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('payment_method','bank')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum('amount');

                $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($opAccount) {
                    $query->where('account_name', $opAccount->account_name)
                    ->orWhere('bank_name', $opAccount->account_name);
                    })
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('payment_method','bank')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum(function ($voucher) {
                        return $voucher->amount + $voucher->new_vat_amount;
                    });
                $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($opAccount) {
                    $query->where('account_name', $opAccount->account_name)
                    ->orWhere('bank_name', $opAccount->account_name);
                    })
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('payment_method','cash')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum(function ($voucher) {
                        return $voucher->amount + $voucher->new_vat_amount;
                    });

                    // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

                $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->sum('total_net_amount');

                $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->sum('total_net_amount');

                $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('type','debit')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum('amount');
                $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('type','credit')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->get()
                    ->sum('amount');

                // dd($ObJournalVoucherNetAmountForDebit,$ObJournalVoucherNetAmountForCredit);

                $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForCash;

                $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;

                $opAccountDetails[$opAccount->class_of_account_id][] = [
                    'account_id' => $opAccount->id,
                    'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
                    'type' => $opAccount->type,
                    'class_of_account_id' => $opAccount->class_of_account_id,
                    'DebitBalance' => $opDebitOBalance,
                    'CreditBalance' => $opCreditOBalance,
                ];
                }

                // $mergedAccountDetails = array_merge($opAccountDetails,$accountDetails,);

                // $totalBalances = [];

                // foreach ($mergedAccountDetails as $classId => $accounts) {
                //     $totalDebit = array_sum(array_column($accounts, 'DebitBalance'));
                //     $totalCredit = array_sum(array_column($accounts, 'CreditBalance'));
                //     $totalBalances[$classId] = [
                //         'TotalDebitBalance' => $totalDebit,
                //         'TotalCreditBalance' => $totalCredit
                //     ];
                // }

                // foreach ($mergedAccountDetails as &$accounts) {
                //     foreach ($accounts as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // // dd($mergedAccountDetails);

                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $accounts) {
                //     foreach ($accounts as $account) {
                //         $classId = $account['class_of_account_id'];

                //         $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //         if (!isset($groupedAccountDetails[$className])) {
                //             $groupedAccountDetails[$className] = [];
                //         }

                //         $groupedAccountDetails[$className][] = $account;
                //     }
                // }

                // dd($groupedAccountDetails);








                // Initialize an empty array to store merged account details
                $mergedAccountDetails = [];

                // Merge the account details
                foreach ($opAccountDetails as $classId => $accounts) {
                    foreach ($accounts as $account) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    }
                }

                foreach ($accountDetails as $classId => $accounts) {
                    foreach ($accounts as $account) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    }
                }

                // Now $mergedAccountDetails contains merged account details with unique account IDs

                foreach ($mergedAccountDetails as $account) {
                    $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                    $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                }

                foreach ($mergedAccountDetails as &$account) {
                    $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                    if ($netBalance > 0) {
                        $account['DebitBalance'] = $netBalance;
                        $account['CreditBalance'] = 0;
                    } else {
                        $account['CreditBalance'] = abs($netBalance);
                        $account['DebitBalance'] = 0;
                    }
                }

                $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                $groupedAccountDetails = [];

                foreach ($mergedAccountDetails as $account) {
                    $classId = $account['class_of_account_id'];
                    $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                    if (!isset($groupedAccountDetails[$className][$account['account_id']])) {
                        $groupedAccountDetails[$className][$account['account_id']] = $account;
                    }
                }

                // Convert the associative array to indexed array
                foreach ($groupedAccountDetails as $className => &$accounts) {
                    $accounts = array_values($accounts);
                }

                // dd($groupedAccountDetails);



                // ab har same class_of_account_id ka DebitBalance or CreditBalance total kar karo

                // $classOfAccountDetails = ClassOfAccount::whereIn('id', array_keys($mergedAccountDetails))->get();

                // $groupedAccountDetails = [];

                // foreach ($classOfAccountDetails as $classOfAccount) {
                //     $groupName = $classOfAccount->name;
                //     $groupedAccountDetails[$groupName] = $mergedAccountDetails[$classOfAccount->id];
                // }

                // foreach ($groupedAccountDetails as $groupName => &$accounts) {
                //     $classId = $accounts[0]['class_of_account_id'];
                //     $totalDebit = $totalBalances[$classId]['TotalDebitBalance'];
                //     $totalCredit = $totalBalances[$classId]['TotalCreditBalance'];

                //     $accounts[] = [
                //         'class_of_account_name' => $groupName,
                //         'DebitBalance' => $totalDebit,
                //         'CreditBalance' => $totalCredit,
                //     ];
                // }


                // dd($groupedAccountDetails);

                // foreach ($mergedAccountDetails as &$account) {
                //     // Calculate net balance
                //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //     // Decide where to show the balance
                //     if ($netBalance > 0) {
                //         // Show on debit side
                //         $account['DebitBalance'] = abs($netBalance);
                //         $account['CreditBalance'] = 0;
                //     } elseif ($netBalance < 0) {
                //         // Show on credit side
                //         $account['CreditBalance'] = abs($netBalance);
                //         $account['DebitBalance'] = 0;
                //     } else {
                //         // Balance is zero, reset both balances
                //         $account['DebitBalance'] = 0;
                //         $account['CreditBalance'] = 0;
                //     }
                // }

                // // Output the updated merged array
                // dd($mergedAccountDetails);

                // // dd($opAccountDetails,$accountDetails);

                // $mergedAccountDetails = array_merge($opAccountDetails,$accountDetails);

                // // dd($mergedAccountDetails);

                // // Iterate through the merged array
                // foreach ($mergedAccountDetails as &$account) {
                //     // Check if 'DebitBalance' and 'CreditBalance' keys exist
                //     if (isset($account['DebitBalance']) && isset($account['CreditBalance'])) {
                //         // Calculate the net balance
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         // Check if the net balance is positive or negative
                //         if ($netBalance > 0) {
                //             // If positive, show on the debit side
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } elseif ($netBalance < 0) {
                //             // If negative, show on the credit side
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         } else {
                //             // If zero, reset both balances
                //             $account['DebitBalance'] = 0;
                //             $account['CreditBalance'] = 0;
                //         }
                //     }
                // }

                // // Output the updated merged array
                // dd($mergedAccountDetails);

                // DebitBalance - CreditBalance nhi horaa

                // DebitBalance ko CreditBalance se minus karo phir jo balance ata hai usko check karo agr balance positive me hai to debit side pe show karo agr  balance negitive me  hai to credit side pe show karo.

                // note: balance ek hi jaga show hoga ya credit side me ya debit side me.






            // Calculate total debit and credit balances for each class of account

            // $totalBalances = [];
            // // $opTotalBalances = [];

            // // Calculate total balances for each class of account
            // foreach ($mergedAccountDetails as $classId => $accounts) {
            //     $totalDebit = array_sum(array_column($accounts, 'DebitBalance'));
            //     $totalCredit = array_sum(array_column($accounts, 'CreditBalance'));
            //     $totalBalances[$classId] = [
            //         'TotalDebitBalance' => $totalDebit,
            //         'TotalCreditBalance' => $totalCredit
            //     ];
            // }

            // foreach ($opAccountDetails as $classId => $opAccounts) {
            //     $opTotalDebit = array_sum(array_column($opAccounts, 'DebitBalance'));
            //     $opTotalCredit = array_sum(array_column($opAccounts, 'CreditBalance'));
            //     $opTotalBalances[$classId] = [
            //         'TotalDebitBalance' => $opTotalDebit,
            //         'TotalCreditBalance' => $opTotalCredit
            //     ];
            // }

            // accountDetails or opAccountDetails ki same classId ke totalDebit + opTotalDebit ,
            // accountDetails or opAccountDetails ki same classId ke totalCredit + opTotalCredit ,


            // dd($accountDetails,$opAccountDetails);


            // Fetch ClassOfAccount details

            // $classOfAccountDetails = ClassOfAccount::whereIn('id', array_keys($accountDetails))->get();

            // $groupedAccountDetails = [];

            // foreach ($classOfAccountDetails as $classOfAccount) {
            //     $groupName = $classOfAccount->name;
            //     $groupedAccountDetails[$groupName] = $accountDetails[$classOfAccount->id];
            // }

            // foreach ($groupedAccountDetails as $groupName => &$accounts) {
            //     $classId = $accounts[0]['class_of_account_id'];
            //     $totalDebit = $totalBalances[$classId]['TotalDebitBalance'];
            //     $totalCredit = $totalBalances[$classId]['TotalCreditBalance'];

            //     $accounts[] = [
            //         'class_of_account_name' => $groupName,
            //         'DebitBalance' => $totalDebit,
            //         'CreditBalance' => $totalCredit,
            //     ];
            // }


            // dd($groupedAccountDetails);


                // Assuming $groupedAccountDetails is already populated with grouped account details

                // Grouping Current Liabilities
                // $currentLiabilitiesGroup = [];
                // $currentLiabilitiesAccounts = ['Sundry Creditors', 'Tax & Duties', 'Current Liabilities'];
                // foreach ($currentLiabilitiesAccounts as $groupName) {
                //     if (isset($groupedAccountDetails[$groupName])) {
                //         $currentLiabilitiesGroup = array_merge($currentLiabilitiesGroup, $groupedAccountDetails[$groupName]);
                //         unset($groupedAccountDetails[$groupName]);
                //     }
                // }
                // $groupedAccountDetails['Current Liabilities'] = $currentLiabilitiesGroup;

                // // Grouping Current Assets
                // $currentAssetsGroup = [];
                // $currentAssetsAccounts = ['Sundry Debtors', 'Cash in Hand', 'Stock in Hand', 'Current Assets', 'Bank Account'];
                // foreach ($currentAssetsAccounts as $groupName) {
                //     if (isset($groupedAccountDetails[$groupName])) {
                //         $currentAssetsGroup = array_merge($currentAssetsGroup, $groupedAccountDetails[$groupName]);
                //         unset($groupedAccountDetails[$groupName]);
                //     }
                // }
                // $groupedAccountDetails['Current Assets'] = $currentAssetsGroup;

                // // Grouping Income
                // $incomeGroup = [];
                // $incomeAccounts = ['Income'];
                // foreach ($incomeAccounts as $groupName) {
                //     if (isset($groupedAccountDetails[$groupName])) {
                //         $incomeGroup = array_merge($incomeGroup, $groupedAccountDetails[$groupName]);
                //         unset($groupedAccountDetails[$groupName]);
                //     }
                // }
                // $groupedAccountDetails['Income'] = $incomeGroup;

                // Printing the results
                // foreach ($groupedAccountDetails as $groupName => $accounts) {
                //     echo "$groupName:\n";
                //     foreach ($accounts as $account) {
                //         echo "Account Name: " . $account['accoun_name'] . ", Debit Balance: " . $account['DebitBalance'] . ", Credit Balance: " . $account['CreditBalance'] . "\n";
                //     }
                //     echo "\n";
                // }




            // dd($groupedAccountDetails);


            // dd($accountDetails);
            return [$groupedAccountDetails,$from_date, $to_date,];

    }













    public function AllAccountsCreateOpeningBalanceWithAllTransactionClosingBalance($request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        // $classOfAccountId = $request->class_of_account;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        // // Vat Report Amount --------------------------------

        // list($debitVatReportCB,$creditVatReportCB) = $this->vatReportService->vatReportClosingBalance($request, $request->from_date, $request->to_date);


        // // dd($debitVatReportCB,$creditVatReportCB);

        // // Cash Report Data -----------------------------------------------------

        // list($debitCashReportCB,$creditCashReportCB) = $this->cashReportService->CashReportServiceClosingBalance($request, $request->from_date, $request->to_date);

        // // Vat Report Data -----------------------------------------------------

        // list($debitDiscountReportCB,$creditDiscountReportCB) = $this->discountReportService->DiscountReportServiceClosingBalance($request, $request->from_date, $request->to_date);

        // from_date to to_date - date range data

        $ClassOfAccount = ClassOfAccount::get();

        $customers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('date_of_joining', '>=', $from_date . ' 00:00:00')
            ->where('date_of_joining', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // dd($allAccounts);

        $allAccountsData = [];

        foreach ($allAccounts as $account) {
            $AccountName = $account->account_name;
            $openingBalanceDebit = null;
            $openingBalanceCredit = null;

            if ($account->type == 'debit' || $account->type == 'Debit') {
                $openingBalanceDebit = $account->opening_balance;
            } elseif ($account->type == 'credit' || $account->type == 'Credit') {
                $openingBalanceCredit = $account->opening_balance;
            }

            // Calculate total purchase invoice amount for the account
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->sum('total_net_amount');

            // Calculate total sale invoice amount for the account
            $SaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->sum('total_net_amount');

            // Add total purchase invoice amount to opening balance debit
            $openingBalanceDebit += $PurchaesInvoice;

            // Add total sale invoice amount to opening balance credit
            $openingBalanceCredit += $SaleInvoice;

            // Add data to $allAccountsData array
            $allAccountsData[] = [
                'name' => $AccountName,
                'opening_balance_debit' => $openingBalanceDebit,
                'opening_balance_credit' => $openingBalanceCredit
            ];
        }

        dd($allAccountsData);


// allAccounts me jo same class_of_account_id pe banein hai wo account ko ClassOfAccount name group wise kar do


        $totalDebit = [];
        $totalCredit = [];
        $obtotalDebit = [];
        $obtotalCredit = [];

        foreach ($allAccounts as $account) {
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $PaymentVoucher = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $ReceiptVoucherForBank = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','bank')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $ReceiptVoucherForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','cash')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                    ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','bank')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $CreditNote = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $DebitNote = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

                // dd($JournalVoucherForDebit,$JournalVoucherForCredit);

            $TotalPurchaesInvoice = $PurchaesInvoice->sum('total_net_amount');
            $TotalDebitNote = $DebitNote->sum('total_net_amount');
            $TotalPaymentVoucher = $PaymentVoucher->sum('amount');
            $TotalJournalVoucherForDebit = $JournalVoucherForDebit->sum('amount');

            $TotalSaleInvoice = $SaleInvoice->sum('total_net_amount');
            $TotalReceiptVoucherForBank = $ReceiptVoucherForBank->sum('amount');
            $TotalReceiptVoucherForCash = $ReceiptVoucherForCash->sum('amount');
            $TotalJournalVoucherForCredit = $JournalVoucherForCredit->sum('amount');
            $TotalCreditNote = $CreditNote->sum('total_net_amount');

            $totalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucher + $TotalDebitNote + $TotalJournalVoucherForDebit + $TotalReceiptVoucherForBank;
            $totalCreditValue = $TotalPurchaesInvoice + $TotalReceiptVoucherForCash + $TotalCreditNote + $TotalJournalVoucherForCredit;

            $totalDebit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'DebitBalance' => $totalDebitValue,
            ];

            // Check if the account type is 'Debit' and update 'DebitBalance' accordingly
            if (strtolower($account->type) === 'debit') {
                $totalDebit[count($totalDebit) - 1]['DebitBalance'] += $account->opening_balance;
            }

            $totalCredit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'creditBalance' => $totalCreditValue,
            ];

            // Check if the account type is 'Credit' and update 'creditBalance' accordingly
            if (strtolower($account->type) === 'credit') {
                $totalCredit[count($totalCredit) - 1]['creditBalance'] += $account->opening_balance;
            }

            }

            // dd($totalDebit,$totalCredit);

        foreach ($allAccounts as $account) {
            $obPurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $obSaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

             $obReceiptVoucher = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')

                ->get();

            $obPaymentVoucher = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                ->get();

            $obCreditNote = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $obDebitNote = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $obJournalVoucherForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->where('type', 'debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $obJournalVoucherForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->where('type', 'credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            // dd($obJournalVoucherForDebit,$obJournalVoucherForCredit);

            $TotalPurchaesInvoice = $obPurchaesInvoice->sum('total_net_amount');
            $TotalDebitNote = $obDebitNote->sum('total_net_amount');
            $TotalPaymentVoucher = $obPaymentVoucher->sum('amount');
            $TotalobJournalVoucherForDebit = $obJournalVoucherForDebit->sum('amount');

            $TotalSaleInvoice = $obSaleInvoice->sum('total_net_amount');
            $TotalReceiptVoucher = $obReceiptVoucher->sum('amount');
            $TotalobJournalVoucherForCredit = $obJournalVoucherForCredit->sum('amount');
            $TotalCreditNote = $obCreditNote->sum('total_net_amount');

            $obTotalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucher + $TotalDebitNote + $TotalobJournalVoucherForDebit;
            $obTotalCreditValue = $TotalPurchaesInvoice  + $TotalReceiptVoucher + $TotalCreditNote + $TotalobJournalVoucherForCredit;


            $Debit = null;
            $Credit = null;

            if ($obTotalDebitValue > $obTotalCreditValue) {
                $Debit = $obTotalDebitValue - $obTotalCreditValue;
            } elseif ($obTotalDebitValue < $obTotalCreditValue) {
                $Credit = $obTotalCreditValue - $obTotalDebitValue;
            }

            $obDebitBalance = $Debit;
            $obcreditBalance = $Credit;

            $obtotalDebit[] = [
                'account_name' => $account->account_name,
                'DebitBalance' => $obDebitBalance,
            ];

            $obtotalCredit[] = [
                'account_name' => $account->account_name,
                'creditBalance' => $obcreditBalance,
            ];

            }

            dd($totalDebit,$totalCredit,$obtotalDebit,$obtotalCredit);

            return [$totalDebit,$totalCredit,$obtotalDebit,$obtotalCredit,$from_date, $to_date,];

    }











}
