@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="row mt-4 mb-1">
                <div class="col-md-6">
                    <h6 class="card-title mb-4 titlcust">View Journal Voucher</h6>
                </div>
                <div class="col-md-6">
                    <a href="">
                        <button class="btn btn-outline-primary float-right cust-btn1" onclick="printPageArea('printableArea')"
                            type="submit">Print Document
                        </button>
                    </a>
                    <a href="">
                        <button class="btn btn-outline-primary float-right" type="submit">Back
                        </button>
                    </a>
                </div>
            </div>

            <div class="card" id="printableArea">
                <div class="card-body">

                    <h6 class="card-title mb-1 text-center font-size-20">Journal Voucher</h6>
                    <br>

                    <div class="row border1">
                        <div class="col-md-2 d-flex align-items-center justify-content-center">
                            <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                width="180px">
                        </div>
                        <div class="col-md-6">
                            <div class="row border1">
                                <div class="pading1">
                                    <div class="col-md-12 ">
                                        {{-- <label>Company Direct</label> --}}

                                        <span>{{ $company->name }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>Branch Name :</label>
                                        <span>{{ session()->get('branch')->name }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>Branch Address :</label>
                                        <span>{{ session()->get('branch')->address }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>VAT Number :</label>
                                        <span>{{ $company->vat_number }}</span>
                                    </div>
                                    <div class="col-md-12">
                                        <label>Email :</label>
                                        <span>{{ $company->email }}</span>
                                    </div>
                                </div>
                            </div>

                            <div class="row border1">
                                <div class="pading1">
                                    <div class="col-md-12">
                                        <h5>Buyer</h5>
                                    </div>
                                    @if ($journalVoucher[0]->buyer != null)
                                        <div class="col-md-12">
                                            {{-- <label>Company Direct</label> --}}

                                            <span>{{ $journalVoucher[0]->account->account_name ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Email :</label>
                                            <span>{{ $journalVoucher[0]->buyer->email ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Contact Person Name :</label>
                                            <span>{{ $journalVoucher[0]->buyer->name ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Contact Number :</label>
                                            <span>{{ $journalVoucher[0]->buyer->phone ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>VAT Number :</label>
                                            <span>{{ $journalVoucher[0]->buyer->vat_number ?? 'No Record Found' }}</span>
                                        </div>
                                    @else
                                        <div>

                                            <span>{{ $journalVoucher[0]->account->name_of_organisation ?? ($journalVoucher[0]->account->account_name ?? $journalVoucher[0]->account->first_name . ' ' . $journalVoucher[0]->account->last_name) }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Email :</label>
                                            <span>{{ $journalVoucher[0]->account->email ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Contact Person Name :</label>
                                            <span>{{ $journalVoucher[0]->account->contact_person_name ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Contact Number :</label>
                                            <span>{{ $journalVoucher[0]->account->mobile ?? 'No Record Found' }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>VAT Number :</label>
                                            <span>{{ $journalVoucher[0]->account->vat_number ?? 'No Record Found' }}</span>
                                        </div>
                                    @endif
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="row border1">
                                <div class="pading1">
                                    <div class="col-md-12">
                                        <label>Voucher #:</label>
                                        <span>{{ $journalVoucher[0]->invoice_no }}</span>
                                    </div>

                                    <div class="col-md-12">
                                        <label>Date :</label>
                                        <span>{{ $journalVoucher[0]->date }}</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <br>


                    <div class="row">
                        <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table class="table table-bordered dt-responsive nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>S No.</th>
                                        <th>Account Name</th>
                                        <th>Narrations</th>
                                        <th>Debit/Credit</th>
                                        <th>Amount</th>
                                    </tr>
                                </thead>

                                <tbody id="table-body">
                                    @forelse ($journalVoucher as $key=>$voucher)
                                        <tr>
                                            <td>{{ $key + 1 }}</td>
                                            <td>
                                                <p>{{ $voucher->account->name_of_organisation ?? $voucher->account->account_name }}
                                                </p>
                                            </td>
                                            <td>
                                                <p>{{ $voucher->narration }}</p>
                                            </td>
                                            <td>
                                                <p>{{ $voucher->type }}</p>
                                            </td>
                                            <td>
                                                <p>{{ $voucher->amount }}</p>
                                            </td>
                                        </tr>
                                    @empty
                                    @endforelse
                                    <tr>
                                        <td></td>
                                        <td>Grand Total</td>
                                        <td></td>
                                        <td></td>
                                        <td id="grand-total"></td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <br>


                    <div class="row">
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                            <strong>
                                <label>Debit Amount:</label>
                                <span id="total-debit-amount">0.000
                                </span>
                            </strong>
                        </div>
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                            <strong>
                                <label>Credit Amount :</label>
                                <span id="total-credit-amount">0.000
                                </span>
                            </strong>
                        </div>
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                            <strong>
                                <label>Difference :</label>
                                <span id="total-difference-amount">0.000
                                </span>
                            </strong>
                        </div>
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                        </div>
                    </div>



                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->

    <script>
        document.addEventListener("DOMContentLoaded", function() {
            // Initialize total amounts
            let totalDebitAmount = 0;
            let totalCreditAmount = 0;

            // Extract journal voucher data from Blade's inline PHP
            const journalVoucher = @json($journalVoucher);

            // Loop through journal vouchers to calculate debit and credit totals
            journalVoucher.forEach(function(voucher) {
                const voucherAmount = parseFloat(voucher.amount);
                const voucherType = voucher.type;

                if (voucherType === "debit") {
                    totalDebitAmount += voucherAmount;
                } else if (voucherType === "credit") {
                    totalCreditAmount += voucherAmount;
                }
            });

            // Calculate the difference between debit and credit
            const totalDifferenceAmount = totalDebitAmount - totalCreditAmount;

            // Update the elements with the calculated values
            document.getElementById("total-debit-amount").textContent = totalDebitAmount.toFixed(2);
            document.getElementById("total-credit-amount").textContent = totalCreditAmount.toFixed(2);
            document.getElementById("total-difference-amount").textContent = totalDifferenceAmount.toFixed(2);

            // Calculate the grand total
            const grandTotal = totalDebitAmount + totalCreditAmount;
            document.getElementById("grand-total").textContent = grandTotal.toFixed(2);
        });
    </script>





    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection
