@extends('layouts.master_user')

@section('css')
<style>
.ibox-title {
    background-color: #efefef;
    border-style: none;
}
.feed-element {
    padding-bottom: 0px;
}
</style>
@endsection
@section('content')
<div class="middle-box text-center animated fadeInDown">
    @include('errors.list')
    <div>
        {{-- <img alt="image" src="/public/user_files/img/acp-logo.png" />
        <h3 class="acp-text-color">Advance Corporate Professionals & Businesses LLC</h3> --}}

        @if ($company)
        @if ($company-> logo)
            <img alt="image" src="/public/user_files/img/company/{{ $company-> logo }}" />
        @endif
            <h3 class="acp-text-color">{{$company->name}}</h3>
        @endif

    </div>
</div>
<div class="hr-line-dashed"></div>
<div class="row m-t-md">
    <div class="col-lg-4">
        <div class="ibox float-e-margins">
            <div class="ibox-title">
                <h5>Reminders</h5>
                {{-- <div class="ibox-tools">
                    <span class="label label-warning-light pull-right">10 Messages</span>
                </div> --}}
            </div>
            <div class="ibox-content">
                <div>
                    <div class="feed-activity-list">
                        @foreach ($remainders as $remainder)
                            <div class="feed-element">
                                <div class="media-body ">
                                    <small class="pull-right">{{$remainder->created_at}}</small>
                                    <strong>{{$remainder->title}}</strong>
                                    <p>{{$remainder->description}}.</p>
                                </div>
                            </div>
                        @endforeach
                    </div>
                    <a href="/others/admin-remainders" class="btn btn-primary btn-block m-t"><i class="fa fa-arrow-down"></i> Show More</a>
                </div>
            </div>
        </div>
    </div>
    <div class="col-lg-4">
        <div class="ibox float-e-margins">
            <div class="ibox-title">
                <h5>Notifications</h5>
                {{-- <div class="ibox-tools">
                    <span class="label label-warning-light pull-right">10 Messages</span>
                </div> --}}
            </div>
            <div class="ibox-content">
                <div>
                    <div class="feed-activity-list">
                        @foreach ($notification as $entry)
                            <div class="feed-element">
                                <div class="media-body ">
                                    <small class="pull-right">{{$entry->created_at}}</small>
                                    <strong>{{$entry->title}}</strong>
                                    <p>{{$entry->description}}.</p>
                                </div>
                            </div>
                        @endforeach
                    </div>
                    <a href="/others/notifications" class="btn btn-primary btn-block m-t"><i class="fa fa-arrow-down"></i> Show More</a>
                </div>
            </div>
        </div>
    </div>
    <div class="col-lg-4">
        <div class="ibox float-e-margins">
            <div class="ibox-title">
                <h5>Document Expiry</h5>
                {{-- <div class="ibox-tools">
                    <span class="label label-warning-light pull-right">10 Messages</span>
                </div> --}}
            </div>
            <div class="ibox-content">
                <div>
                    <div class="feed-activity-list">
                        @foreach ($account_master_docs as $item)
                            @if ($item->doc_name_1 != "")
                                @if ( ( $item->doc_expiry_1 >= Carbon\Carbon::now()->format('Y-m-d') )
                                        &&
                                        $item->doc_expiry_1 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_1}}</small>
                                            <strong>{{$item->doc_name_1}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        {{-- @endforeach
                        @foreach ($account_master_docs as $item) --}}
                            @if ($item->doc_name_2 != "")
                                @if ( ( $item->doc_expiry_2 >= Carbon\Carbon::now()->format('Y-m-d') )
                                        &&
                                        $item->doc_expiry_2 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_2}}</small>
                                            <strong>{{$item->doc_name_2}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        {{-- @endforeach
                        @foreach ($account_master_docs as $item) --}}
                            @if ($item->doc_name_3 != "")
                                @if ( ( $item->doc_expiry_3 >= Carbon\Carbon::now()->format('Y-m-d') )
                                            &&
                                            $item->doc_expiry_3 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_3}}</small>
                                            <strong>{{$item->doc_name_3}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        {{-- @endforeach
                        @foreach ($account_master_docs as $item) --}}
                            @if ($item->doc_name_4 != "")
                                @if ( ( $item->doc_expiry_4 >= Carbon\Carbon::now()->format('Y-m-d') )
                                            &&
                                            $item->doc_expiry_4 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_4}}</small>
                                            <strong>{{$item->doc_name_4}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        {{-- @endforeach
                        @foreach ($account_master_docs as $item) --}}
                            @if ($item->doc_name_5 != "")
                                @if ( ( $item->doc_expiry_5 >= Carbon\Carbon::now()->format('Y-m-d') )
                                            &&
                                            $item->doc_expiry_5 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_5}}</small>
                                            <strong>{{$item->doc_name_5}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        {{-- @endforeach
                        @foreach ($account_master_docs as $item) --}}
                            @if ($item->doc_name_6 != "")
                                @if ( ( $item->doc_expiry_6 >= Carbon\Carbon::now()->format('Y-m-d') )
                                            &&
                                            $item->doc_expiry_6 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_6}}</small>
                                            <strong>{{$item->doc_name_6}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        {{-- @endforeach
                        @foreach ($account_master_docs as $item) --}}
                            @if ($item->doc_name_7 != "")
                                @if ( ( $item->doc_expiry_7 >= Carbon\Carbon::now()->format('Y-m-d') )
                                            &&
                                            $item->doc_expiry_7 <= Carbon\Carbon::now()->addDays(30)->format('Y-m-d')
                                )
                                    <div class="feed-element">
                                        <div class="media-body ">
                                            <small class="pull-right">{{$item->doc_expiry_7}}</small>
                                            <strong>{{$item->doc_name_7}}</strong>
                                            <p>In Account Master {{$item->account_master_type}} => {{$item->name_of_organisation}}.</p>
                                        </div>
                                    </div>
                                @endif
                            @endif
                        @endforeach
                    </div>
                    <a href="/others/document-expiry" class="btn btn-primary btn-block m-t"><i class="fa fa-arrow-down"></i> Show More</a>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection







@section('js')

@endsection
