@extends('layouts.master_user_without_nav')
@section('css')
<style>
    .margin_top{
        margin-top: 50px;
    }
    h2{
        margin-bottom: 20px;
    }
    #custom-search-input {
        padding: 3px;
        border: solid 1px #E4E4E4;
        border-radius: 6px;
        background-color: #fff;
    }

    #custom-search-input input {
        border: 0;
        box-shadow: none;
    }

    #custom-search-input button {
        margin: 2px 0 0 0;
        background: none;
        box-shadow: none;
        border: 0;
        color: #666666;
        padding: 0 8px 0 10px;
        border-left: solid 1px #ccc;
    }

    #custom-search-input button:hover {
        border: 0;
        box-shadow: none;
        border-left: solid 1px #ccc;
    }

    #custom-search-input .glyphicon-search {
        font-size: 23px;
    }


</style>
@endsection
@section('content')
<div class="container wrapper wrapper-content animated fadeInRight">
    <div class="row gray-bg margin_top" style="margin-bottom: 50px;">
        <h2 class="text-center"><strong>Search Result For {{$search_voucher}}</strong></h2>
    </div>
    @if ($search_voucher == "approval-vouchers")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Account</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $approval)
                            <tr>
                                <td>{{$approval->invoice_no}}</td>
                                <td>{{$approval->date}}</td>
                                <td>{{$approval->account->name_of_organisation}}</td>
                                <td>
                                    @if ($approval->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('view-print-approval-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/approval-vouchers/{{ $approval->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div>
                                            @endcan

                                            @can('edit-approval-voucher-delivery-notes')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/approval-vouchers/{{ $approval->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan

                                            @can('cancel-approval-voucher-delivery-notes')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <form  method="post" action="/transactions/approval-vouchers/{{ $approval->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                            @if ($approval->is_signed == 1)
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/public/user_files/img/client_signs/{{$approval->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                                </div>
                                            @else
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/transactions/approval-vouchers/signature/{{ $approval->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                                </div>
                                            @endif
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "sales-invoices")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Account</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $sales)
                            <tr>
                                <td>{{$sales->invoice_no}}</td>
                                <td>{{$sales->date}}</td>
                                <td>{{$sales->account->name_of_organisation}}</td>
                                <td>
                                    @if ($sales->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('view-print-sales-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/sales-invoices/{{ $sales->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div>
                                            @endcan
                                            @if ($sales->paid_amount == 0)
                                                @can('edit-sales-voucher')
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <a href="/transactions/sales-invoices/{{ $sales->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                                </div>
                                                @endcan
                                                @can('cancel-sales-voucher')
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <form  method="post" action="/transactions/sales-invoices/{{ $sales->id }}/softdelete">
                                                        {{ csrf_field() }}
                                                        {{ method_field('DELETE') }}
                                                        <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                    </form>
                                                </div>
                                                @endcan
                                            @else
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <button type="button" disabled class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</button>
                                                </div>
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <button type="button" disabled class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </div>
                                            @endif
                                            @if ($sales->is_signed == 1)
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/public/user_files/img/client_signs/{{$sales->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                                </div>
                                            @else
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/transactions/sales-invoices/signature/{{ $sales->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                                </div>
                                            @endif
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "purchase-invoices")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Account</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $key => $voucher)
                            <tr>
                                <td>{{ $vouchers[$key]->invoice_no }}</td>
                                <td>{{ $vouchers[$key]->date }}</td>
                                <td>{{ $vouchers[$key]->account->name_of_organisation }}</td>
                                <td>
                                    @if ($vouchers[$key]->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('view-Print-purchase-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/purchase-invoices/{{ $vouchers[$key]->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div>
                                            @endcan
                                            @if ($vouchers[$key]->paid_amount == 0 && $sales_items[$key] == "")
                                                @can('edit-purchase-voucher')
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <a href="/transactions/purchase-invoices/{{ $vouchers[$key]->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                                </div>
                                                @endcan

                                                @can('cancel-purchase-voucher')
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <form  method="post" action="/transactions/purchase-invoices/{{ $vouchers[$key]->id }}/softdelete">
                                                        {{ csrf_field() }}
                                                        {{ method_field('DELETE') }}
                                                        <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                    </form>
                                                </div>
                                                @endcan
                                            @else
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <button type="button" disabled class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</button>
                                                </div>
                                                <div class="pull-left" style="margin-right: 10px;">
                                                    <button type="button" disabled class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </div>
                                            @endif
                                            @if ($voucher->is_signed == 1)
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/public/user_files/img/client_signs/{{$voucher->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                                </div>
                                            @else
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/transactions/purchase-invoices/signature/{{ $voucher->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                                </div>
                                            @endif
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "sales-return-vouchers")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Account</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $sales_return)
                            <tr>
                                <td>{{$sales_return->invoice_no}}</td>
                                <td>{{$sales_return->date}}</td>
                                <td>{{$sales_return->account->name_of_organisation}}</td>
                                <td>
                                    @if ($sales_return->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('view-print-credit-note-sales-return-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/sales-return-vouchers/{{ $sales_return->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div>
                                            @endcan
                                            @can('edit-credit-note-sales-return-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/sales-return-vouchers/{{ $sales_return->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan

                                            @can('cancel-credit-note-sales-return-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <form  method="post" action="/transactions/sales-return-vouchers/{{ $sales_return->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                            @if ($sales_return->is_signed == 1)
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/public/user_files/img/client_signs/{{$sales_return->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                                </div>
                                            @else
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/transactions/sales-return-vouchers/signature/{{ $sales_return->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                                </div>
                                            @endif
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "purchase-return-vouchers")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Account</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $purchase_return)
                            <tr>
                                <td>{{$purchase_return->invoice_no}}</td>
                                <td>{{$purchase_return->date}}</td>
                                <td>{{$purchase_return->account->name_of_organisation}}</td>
                                <td>
                                    @if ($purchase_return->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('view-print-debit-note-purchase-return-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div>
                                            @endcan
                                            @can('edit-debit-note-purchase-return-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan

                                            @can('cancel-debit-note-purchase-return-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <form  method="post" action="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                            @if ($purchase_return->is_signed == 1)
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/public/user_files/img/client_signs/{{$purchase_return->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                                </div>
                                            @else
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/transactions/purchase-return-vouchers/signature/{{ $purchase_return->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                                </div>
                                            @endif
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "payment-vouchers")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $payment_voucher)
                            <tr>
                                <td>{{$payment_voucher->invoice_no}}</td>
                                <td>{{$payment_voucher->date}}</td>
                                <td>
                                    @if ($payment_voucher->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('edit-payment-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/payment-vouchers/{{ $payment_voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan

                                            @can('cancel-payment-voucher')
                                            <div class="pull-right">
                                                <form  method="post" action="/transactions/payment-vouchers/{{ $payment_voucher->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "receipt-vouchers")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $receipt_voucher)
                            <tr>
                                <td>{{$receipt_voucher->invoice_no}}</td>
                                <td>{{$receipt_voucher->date}}</td>
                                <td>
                                    @if ($receipt_voucher->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('edit-receipt-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/receipt-vouchers/{{ $receipt_voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan
                                            @can('cancel-receipt-voucher')
                                            <div class="pull-right">
                                                <form  method="post" action="/transactions/receipt-vouchers/{{ $receipt_voucher->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @elseif ($search_voucher == "journal-vouchers")

        @if(count($vouchers) > 0)
            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                    <thead>
                        <tr>
                            <th>Invoice Number</th>
                            <th>Date</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($vouchers as $journal_voucher)
                            <tr>
                                <td>{{$journal_voucher->voucher_no}}</td>
                                <td>{{$journal_voucher->date}}</td>
                                <td>
                                    @if ($journal_voucher->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">

                                            @can('edit-journal-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/journal-vouchers/{{ $journal_voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan
                                            @can('cancel-journal-voucher')
                                            <div class="pull-right">
                                                <form  method="post" action="/transactions/journal-vouchers/{{ $journal_voucher->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        </div>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        @else
            <h4>No Vouchers Found</h4>
        @endif

    @endif

    {{-- @if(count($vouchers) != 0)
        <div class="table-responsive">
            <table class="table table-striped table-bordered table-hover dt-responsive" >
            <thead>
            <tr>
                <th>Invoice Number</th>
                <th>Date</th>
                <th>Account</th>
                <th>Action</th>
            </tr>
            </thead>
            <tbody>
                @foreach($vouchers as $voucher)
                <tr>
                    @if ($search_voucher  == "journal-vouchers")
                        <td>{{$voucher->voucher_no}}</td>
                    @else
                        <td>{{$voucher->invoice_no}}</td>
                    @endif

                    <td>{{$voucher->date}}</td>
                    <td>{{$voucher->account_id}}</td>
                    <td>
                        <div class="btn-group">
                            @if ($search_voucher  == "sales-invoices" || $search_voucher  == "purchase-invoices" || $search_voucher  == "sales-return-vouchers" || $search_voucher  == "purchase-return-vouchers")
                                <div class="pull-left" style="margin-right: 10px;">
                                    <a href="/transactions/{{$search_voucher}}/{{ $voucher->id }}/view" class="btn btn-primary">
                                        <i class="fa fa-eye" aria-hidden="true"></i>
                                        View
                                    </a>
                                </div>
                            @endif

                            <div class="pull-left" style="margin-right: 10px;">
                                <a href="/transactions/{{$search_voucher}}/{{ $voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                            </div>
                            <div class="pull-right">
                                <form  method="post" action="/main-menu/notification/{{ $voucher->id }}">
                                    {{ csrf_field() }}
                                    {{ method_field('DELETE') }}
                                    <button type="submit" class="btn btn-primary">
                                        <i class="fa fa-trash" aria-hidden="true"></i>
                                        Delete</button>
                                </form>
                            </div>
                        </div>
                    </td>
                </tr>
                @endforeach
            </tbody>
            </table>
        </div>
    @else
        <h4>No Vouchers Found</h4>
    @endif --}}
</div>
@endsection

@section('js')
<script>
</script>
@endsection
