@extends('layouts.master_user')
@section('page-title')
Item Name Master
@endsection
@section('css')
<style>
    .top {
        margin-top: 22px;
    }
</style>

@endsection
@section('master')
active
@endsection
@section('item-id-master')
active
@endsection
@section('content')
{{--
@section('page-breadcrumb')
<li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Customer Master</strong>
</li>
@endsection--}}

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Add Customers</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}
        <div class="ibox-content">
            <form id="create_form" class="form-horizontal" method="POST" action="/masters/item-names" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <div class="col-sm-12">
                        <label>Item Group</label>
                        <select name="group_id"class="form-control" id="group_id">
                            @foreach ($item_groups as $item_group)
                                <option value="{{$item_group->id}}">{{$item_group->name}}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
                <div class="form-group">
                        <div class="col-sm-12">
                            <div class="table-responsive">
                                <table class="table table-bordered table-hover" id="item_table">
                                    <thead>
                                        <tr>
                                            <th scope="col">Item Name</th>
                                            <th scope="col">Item Unit</th>
                                            {{-- <th scope="col"> Stock Availability</th> --}}
                                            <th scope="col">Delete</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td>
                                                <input type="text" id="name" name="name[]" placeholder="Item Name" class="form-control" required />
                                            </td>
                                            <td>
                                                <select name="unit_id[]" class="form-control" id="unit_id" required>
                                                    @foreach ($item_units as $item_unit)
                                                        <option value="{{$item_unit->id}}">{{$item_unit->unit}}</option>
                                                    @endforeach
                                                </select>
                                            </td>
                                            {{-- <td>
                                                <select class="form-control" name="stock_availability[]" id="stock_availability">
                                                    <option value="1">Yes</option>
                                                    <option value="0">No</option>
                                                </select>
                                            </td> --}}
                                            <td>
                                                <button type="button" class="btn" id="delete_item_button" disabled><i
                                                        class="fa fa-trash-o icon-trash"></i></button>
                                            </td>
                                            </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-12">
                        <button type="button" class="btn btn-primary"
                        onclick="createItemRow(1)"><i class="feather icon-plus"></i> Add Item Name
                        </button>
                    </div>
                </div>
                    <div class="form-group">
                    <div class="col-sm-12">
                        <button class="btn btn-primary pull-right" type="submit">Save Item Name</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
$('#create_form').validate(
        {ignore : ":hidden:not(.selectpicker)"  }
    );

function createItemRow() {
    $('#item_table').append('<tr><td><input type="text" id="name" name="name[]" placeholder="Item Name" class="form-control" required /></td>' +
        '<td>' +
            '<select name="unit_id[]" class="form-control" id="unit_id">' +
                '@foreach ($item_units as $item_unit)' +
                    '<option value="{{$item_unit->id}}">{{$item_unit->unit}}</option>' +
                '@endforeach' +
            '</select>' +
        '</td>' +
        // '<td>' +
        //     '<select class="form-control" name="stock_availability[]" id="stock_availability">' +
        //         '<option value="1">Yes</option>' +
        //         '<option value="0">No</option>' +
        //     '</select>' +
        // '</td>'+
        '<td><button type="button" class="btn" id="delete_item_button"><i class="fa fa-trash-o icon-trash"></i></button></td>' +
        '</tr>');
}

$('#item_table').on('click', 'button[id="delete_item_button"]', function () {
    $(this).closest('tr').remove();
    });

</script>
@endsection
