@extends('layouts.master_user')
@section('page-title')
Warehouses
@endsection
@section('css')
<style>
</style>
@endsection
@section('master')
active
@endsection
@section('warehouses')
active
@endsection
@section('content')

{{-- @section('page-breadcrumb')
<li>
    <a href="/admin">Warehouses</a>
</li>
<li class="active">
    <strong>Warehouses</strong>
</li>
@endsection --}}

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="row wrapper white-bg page-heading">
        <div class="col-md-12">
            <a href="/masters/warehouses/create" class="btn btn-primary pull-right"><i class="fa fa-plus" aria-hidden="true"></i> Create Warehouse</a>
        </div>
        @if(count($warehouses) != 0)
        <div class="col-md-12">
            <div class="card strpied-tabled-with-hover" style="padding-top: 20px;">
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered table-hover dt-responsive" >
                        <thead>
                        <tr>
                            <th>Warehouse Name</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                            @foreach($warehouses as $warehouse)
                            <tr>
                                <td>{{ $warehouse->name }}</td>
                                <td>
                                    {{-- @if ($warehouse->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else --}}
                                        <div class="btn-group">
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/masters/warehouses/{{ $warehouse->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            {{-- <div class="pull-right">
                                                <form  method="post" action="/masters/warehouses/{{ $warehouse->id }}">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                </form>
                                            </div> --}}
                                            <div class="pull-right">
                                                @php
                                                   $count = App\PurchaseSalesTransferStockTrack::where('warehouse_id' ,$warehouse->id)->count();
                                                @endphp
                                                @if ($count == 0)
                                                    <form  method="post" action="/masters/warehouses/{{ $warehouse->id }}/softdelete">
                                                        {{ csrf_field() }}
                                                        {{ method_field('DELETE') }}
                                                        <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                    </form>
                                                @else
                                                <button type="button" disabled class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                @endif
                                            </div>
                                        </div>
                                    {{-- @endif --}}
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        </table>
                        @if ($warehouses->hasPages())
                        <tfoot>
                            <tr>
                                <td colspan="6" class="footable-visible text-center">
                                    {!! $warehouses->links() !!}
                                </td>
                            </tr>
                        </tfoot>
                        @endif
                    </div>
                </div>
            </div>
        </div>
        @else
            <h4 style="text-align:center;">No warehouse has been created yet.</h4>
        @endif
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function(){
        $('.dataTables-warehouses').DataTable({
            pageLength: 25,
            dom: '<"html5buttons"B>lTfgitp',
            buttons: [
                { extend: 'copy'},
                {extend: 'csv'},
                {extend: 'excel', title: 'ExampleFile'},
                {extend: 'pdf', title: 'ExampleFile'},

                {extend: 'print',
                 customize: function (win){
                        $(win.document.body).addClass('white-bg');
                        $(win.document.body).css('font-size', '10px');

                        $(win.document.body).find('table')
                                .addClass('compact')
                                .css('font-size', 'inherit');
                }
                }
            ]

        });

    });

</script>
@endsection
