
@extends('layouts.master_user')
@section('page-title')
Statement of Accounts
@endsection
@section('css')
<style>
    .top {
        margin-top: 22px;
    }

    .vcenter {
        margin-top: 30px;
    }

    .move_l {
        margin-right: 10px;

    }

    .display-none {
        display: none;
    }

    .display-min {
        width: 280px;
    }

    #top {
        margin-top: 100px;
    }
    th{
        text-align: center;
    }
</style>

@endsection
@section('reports')
active
@endsection
@section('Balance-Inquiry-Report')
active
@endsection
@section('content')

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Expense</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}
        <div class="ibox-content">
            <form method="get" class="form-horizontal">
                <div class="form-group">
                    <div class="col-sm-4">
                        <label>From Date </label>
                        <div class="input-group date">
                            <span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text"
                                class="form-control" value="">
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <label>To Date </label>
                        <div class="input-group date">
                            <span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text"
                                class="form-control" value="">
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-6">
                        <label for="account_class_or_Ledger">Select Type of report</label>
                        <select class="ledger_account_class form-control" id="ledger_account_class_id"
                            name="ledger_account_class_name" onchange="showLedgerAccount()" required>
                            <option value="">Select</option>
                            <option value="ledger">Ledger Wise</option>
                            <option value="account">Class of Account</option>
                        </select>
                    </div>
                </div>
                <table class="table table-bordered table-hover">
                    <thead>
                        <tr>
                            <th width="50%">Particulars</th>
                            <th width="25%">Amount</th>
                            <th width="25%">Info</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>
                                <p id="ledger_class_of_account">Particulars</p>
                                <div id="account_class" class="display-none">
                                    <select class="form-control" id="class_of_account">
                                        <option value="">Select Class of Account</option>
                                        <option value="1">Bank Account</option>
                                        <option value="2">Capital Account</option>
                                        <option value="2">Cash in Hand</option>
                                        <option value="2">Current Assets</option>
                                        <option value="2">Current Liabilities</option>
                                        <option value="2">Expenses</option>
                                        <option value="2">Income</option>
                                        <option value="2">Fixed Assets</option>
                                        <option value="2">Loans</option>
                                        <option value="2">Advance</option>
                                        <option value="2">Reserves & Surplus</option>
                                        <option value="2">Retained Earnings</option>
                                        <option value="2">Stock in Hand</option>
                                        <option value="2">Non Current Liabilites </option>
                                        <option value="2">Sundry Creditors</option>
                                        <option value="2">Sundry Debtors</option>
                                        <option value="2">Suspence Account</option>
                                    </select>
                                </div>
                                <div id="ledger_class" class="display-none">
                                    <select class="form-control" id="ledger_class">
                                        <option value="">Select Ledger</option>
                                        <option value="">Ledger Name</option>
                                        <option value="">Ledger Name</option>
                                        <option value="">Ledger Name</option>
                                    </select>
                                </div>
                            </td>
                            <td>
                                <Strong>
                                    <p>Rs:0</p>
                                </Strong>
                            </td>
                            <td class="display-min">
                                <button type="button" class="btn" id="customer_info_btn"><i
                                        class="fa fa-info"></i></button>
                                <div id="customer_info" class="display-none">
                                    <p>Contact Person Name: Test</p>
                                    <p>Contact #:1234567</p>
                                    <p>WhatsApp:1234567</p>
                                    <p>Email:test@gmail.com</p>
                                    <p>Address: House# , street#, City, Country</p>
                                </div>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </form>
            <div class="form-group top">
                <button class="btn btn-secondary " type="button"><i class="fa fa-check"></i>&nbsp;Display</button>
            </div>
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "dd/mm/yyyy"
        }).datepicker('setDate',new Date());
    });
            function showLedgerAccount(){
                var select_status=$('#ledger_account_class_id').val();
                if(select_status=='account'){
                    $('#account_class').show();
                    $('#ledger_class').hide();
                    $('#ledger_class_of_account').hide();

                }
                if(select_status=='ledger'){
                    $('#ledger_class').show();
                    $('#account_class').hide();
                    $('#ledger_class_of_account').hide();

                }
                if(select_status==''){
                    $('#account_class').hide();
                    $('#ledger_class').hide();
                    $('#ledger_class_of_account').show();
                }
            }
            function showAndHideInfo(){
                var select_status=$('#report_type').val();
                if(select_status=='billwise_report'){
                    $('#customer_info_btn').show();
                    $('#customer_info_th').show();
                }
                if(select_status=='vat_report'){
                    $('#customer_info_btn').hide();
                    $('#customer_info_th').hide();

                }
                if(select_status==''){
                    $('#customer_info_btn').hide();
                    $('#customer_info').hide();
                    $('#customer_info_th').hide();
                    }
            }
    $(document).ready(function () {
    $("#customer_info_btn").click(function () {
    $("#customer_info").toggle();
    });
});
</script>
@endsection
