@extends('layouts.master_user')
@section('page-title')
Complete Stock Query
@endsection
@section('css')
<style>

    .display-none {
        display: none;
    }
    .display-min{
        width:280px;
    }
    th{
        text-align: center;
    }


</style>

@endsection
@section('reports')
active
@endsection
@section('stock-report')
active
@endsection

@section('content')

@section('page-breadcrumb')
{{-- <li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Ledger Report</strong>
</li> --}}
@endsection

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Expense</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}

        <div class="ibox-content">
            <div class="row m-b-md top">
                {{-- <div class="col-sm-3">
                    <p><strong>Date: </strong><strong>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</strong></p>
                </div> --}}
                <div class="col-sm-12">
                    <div class="form-group pull-right">
                        {{-- <button class="btn btn-secondary " type="button"><i class="fa fa fa-print"></i>&nbsp;&nbsp;<span
                                class="bold">Print</span></button> --}}
                                <a href="/reports/stock-report/pdfview/complete/{{$from_date}}/{{$to_date}}/{{ $show_cost }}" target="_blank" class="btn btn-primary"><i class="fa fa fa-print"> Print </i> & <i class="fa fa-file-pdf-o">  PDF Format</i></a>
                        <button class="btn btn-secondary " type="button"><i class="fa fa fa-envelope"></i>&nbsp;&nbsp;Email (PDF
                            Format)</button>
                            <button type="button" class="btn" id="customer_info_btn"><i
                                class="fa fa-info"></i></button>
                        <div id="customer_info" class="display-none">
                            <p>Contact Person Name: Test</p>
                            <p>Contact #:1234567</p>
                            <p>WhatsApp:1234567</p>
                            <p>Email:test@gmail.com</p>
                            <p>Address: House# , street#, City, Country</p>
                        </div>
                    </div>
                </div>
            </div>
            <table class="table table-bordered table-hover">
                <thead>
                  <tr>
                    <th>Item Name</th>
                    <th>QTY</th>
                    <th>Unit</th>
                    @if ($show_cost == 1)
                        <th>Rate</th>
                        <th>Net Amount</th>
                    @endif
                  </tr>
                </thead>
                <tbody>
                    @php
                        $total_amount = 0;
                    @endphp
                    @foreach ($groups as $group)
                        @php
                            $group_total_qty = 0;
                            $group_total_amount = 0;
                            $purchase_invoice = '';
                        @endphp

                        @foreach($group->item_names as $key => $item_name)
                        @php
                            $item_quantity = $item_name->purchase_sales_transfer_stock_tracks->where('item_name_id', $item_name->id)->sum('quantity');
                            $item_amount = $item_name->purchase_sales_transfer_stock_tracks->where('item_name_id', $item_name->id)->where('quantity', '>', 0)->sum('amount');
                        @endphp
                        @if ($item_quantity > 0)
                            <tr>
                                <td>
                                    <form class="form-horizontal" method="POST" action="/reports/stock-report" enctype="multipart/form-data">
                                        @csrf
                                        <input type="hidden" id="item_stock" name="item_stock" class="form-control" value="{{ $item_name->id }}">
                                        <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                        <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                        <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="item_query">
                                        <button class="btn" style="background:transparent" type="submit"><b>{{$item_name->name}}</b></button>
                                    </form>
                                </td>
                                <td>{{$item_quantity}}</td>
                                <td>{{$item_name->units->unit}}</td>
                                @if ($show_cost == 1)
                                    <td>{{ number_format($item_amount /$item_quantity, $decimal, '.', '') }}</td>
                                    <td>{{number_format($item_amount, $decimal, '.', '')}}</td>
                                @endif
                            </tr>
                        @endif

                        @foreach ($item_name->purchase_sales_transfer_stock_tracks as $key => $purchase_sales_transfer_stock_track)
                            @if ($purchase_sales_transfer_stock_track->quantity != 0)
                                @php
                                    $purchase_invoice = $item_name->purchase_sales_transfer_stock_tracks->where('item_name_id', $purchase_sales_transfer_stock_track->item_name_id)->where('imei_serial_no', $purchase_sales_transfer_stock_track->imei_serial_no)->first();
                                        if($purchase_invoice){
                                            $group_rate_per_quantity = $purchase_invoice->rate_per_quantity;
                                        }else{
                                            $group_rate_per_quantity = 0;
                                    }
                                    $group_total_qty = $group_total_qty + $purchase_sales_transfer_stock_track->quantity;
                                    $group_total_amount = $group_total_amount + $purchase_sales_transfer_stock_track->amount;
                                    $total_amount = $total_amount + $purchase_sales_transfer_stock_track->amount;
                                @endphp
                            @endif
                        @endforeach

                    @endforeach
                        @if ($group_total_qty != 0)
                        <tr>
                            <td><strong>{{$group->name}}</strong></td>
                            <td><strong>{{ $group_total_qty }}</strong></td>
                            <td></td>
                            @if ($show_cost == 1)
                                <td></td>
                                {{-- @if ($group_total_amount > 0 && $group_total_qty > 0)
                                    <td><strong>{{ number_format($group_total_amount / $group_total_qty, $decimal, '.', '') }}</strong></td>
                                @else
                                    <td><strong>{{number_format(0, $decimal, '.', '')}}</strong></td>
                                @endif --}}
                                <td><strong>{{ number_format($group_total_amount, $decimal, '.', '') }}</strong></td>
                            @endif
                        </tr>
                        @endif
                    @endforeach

                </tbody>
              </table>
              @if ($show_cost == 1)
                <div class="row">
                    <div class="col-md-3 col-md-offset-9">
                        <p><strong>Total Amount : {{ number_format($total_amount, $decimal, '.', '') }}</strong></p>
                    </div>
                </div>
                @endif
              {{-- <div class="row">
                  <div class="col-sm-2 col-sm-offset-10">
                      <p><strong>Total Remaining Quantity : <span id="total_quantity"></span></strong></p>
                  </div>
              </div>
              <div class="row">
                <div class="col-sm-2 col-sm-offset-10">
                    <p><strong>Total Remaining Value : <span id="total_value"></span></strong></p>
                </div>
            </div> --}}
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    var quantity = 0;
    $('.quantity').each(function(){
        quantity += parseFloat(this.value);
    });
    $('#total_quantity').text(quantity);

    var value = 0;
    $('.value').each(function(){
        value += parseFloat(this.value);
    });
    $('#total_value').text(value);

    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "dd/mm/yyyy"
        }).datepicker('setDate',new Date());
    });
            function showLedgerAccount(){
                var select_status=$('#ledger_account_class_id').val();

                if(select_status=='account'){
                    $('#account_class').show();
                    $('#select').hide();
                }
                else{
                    $('#account_class').hide();
                    $('#select').show();


                }
            }
    $(document).ready(function () {
    $("#customer_info_btn").click(function () {
    $("#customer_info").toggle();
    });
});
</script>
@endsection
