@extends('layouts.master_user')
@section('page-title')
Warehouse Transfer
@endsection
@section('css')
<style>
    th{
        text-align: center;
    }
</style>

@endsection
@section('transaction')
active
@endsection
@section('warehouse-stock-transfer')
active
@endsection
@section('content')
{{--
    @section('page-breadcrumb')
<li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Purchase Invoice</strong>
</li>
@endsection --}}

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    {{-- <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>Invoice</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
         </div> --}}
    <div class="ibox-content">

        <form id="create_form" class="form-horizontal" method="POST" action="/transactions/warehouse-stock-transfers/{{  $warehouse_stock_transfer -> id }}" enctype="multipart/form-data">
            {{ method_field('PATCH') }}
            {{ csrf_field() }}
            {{-- <div class="row">
        <div class="col-sm-12">
        <button class="btn btn-secondary pull-right" type="submit">Print </button>
        </div>
    </div> --}}
                {{-- <div class="col-sm-6">
                    <div class="col-sm-4">
                        <p id="warehouse_stock_transfer_no"><b>WST # 124567</b></p>
                        <p id="date"><b>Date : 24/11/2020</b></p>
                    </div>
                </div> --}}
                <div class="form-group">
                    <div class="col-sm-3">
                        <label>WST#</label>
                        <input type="text" class="form-control" value="{{ $warehouse_stock_transfer-> warehouse_stock_transfer_no }}" name="warehouse_stock_transfer_no" id="warehouse_stock_transfer_no"
                            placeholder="WST#" readonly>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-3">
                        <label for="">Date</label>
                            <div class="input-group date">
                                <span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text"
                            class="form-control" name="date" id="date" value="{{ $warehouse_stock_transfer-> date }}" readonly>
                            </div>
                    </div>
                </div>
                <table class="table table-bordered" id="item_table">
                    <thead>
                        <tr>
                            <th>
                                <p>Item Name</p>
                            </th>
                            {{-- <th>
                                <p>Color</p>
                            </th> --}}
                            <th>
                                <p>From Warehouse</p>
                            </th>
                            <th>IMEI/Serial #</th>
                            <th>To Warehouse</th>
                            <th>Remarks</th>
                            <th>
                                <button type="button" class="btn" id="delete_item_button" disabled
                                    onclick="deleteItemsRow()"><i class="fa fa-trash-o icon-trash"></i></button>
                            </th>
                            <th>
                                <button type="button" class="btn" id="duplicate_item_button" onclick="duplicate()"
                                    disabled><i class="fa fa-files-o"></i></button>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($warehouse_stock_transfer->items as $key =>$warehouse_stock_transfer_item)
                        @php
                            $item_id = \App\PurchaseSalesTransferStockTrack::where(['imei_serial_no' => $warehouse_stock_transfer_item->imei_serial_no])->first()->id;
                        @endphp
                        <tr>
                            <td width="15%">
                                {{-- <span id="item_name">{{ \App\PurchaseInvoiceItem::with('name')->where(['imei_serial_no' => $warehouse_stock_transfer_item->imei_serial_no])->first()->name->name }}</span> --}}
                                <span id="item_name">{{ $warehouse_stock_transfer_item->selectedItem->name->name }}</span>
                            </td>
                            {{-- <td width="15%">
                                <span id="color">{{ $warehouse_stock_transfer_item->selectedItem->color }}</span>
                            </td> --}}
                            <td width="15%">
                                {{-- <select name="from_wareHouse[]" class="form-control" id="from_wareHouse">
                                    <option value="">Select Warehouse ...</option>
                                    @foreach ($warehouses as $warehouse)
                                        @if (!empty($warehouse->warehouse))
                                            <option value="{{$warehouse->warehouse->id}}" @if ($warehouse->warehouse->id == $warehouse_stock_transfer_item->from_wareHouse) selected="selected" @endif>{{$warehouse->warehouse->name}}</option>
                                        @endif
                                    @endforeach
                                </select> --}}
                                <span id="f_warehouse">{{$warehouse_stock_transfer_item->fromWarehouse->name}}</span>
                                <input type="hidden" name="from_warehouse[]" class="form-control" id="from_warehouse" value="{{$warehouse_stock_transfer_item->from_wareHouse}}" required>
                                <input type="hidden" name="item_id[]" class="form-control" id="item_id" value="{{$item_id}}" required>
                            </td>
                            <td width="15%">
                                <select name="imei_serial_no[]" class="form-control imei_serial_no" id="imei_serial_no" required>
                                    <option value="">Select IMEI/Serial #</option>
                                    @foreach ($items as $item)
                                    <option value="{{$item->imei_serial_no}}"  @if ($item->imei_serial_no == $warehouse_stock_transfer_item->imei_serial_no) selected="selected" @endif>{{$item->imei_serial_no}}</option>
                                    @endforeach
                                </select>
                            </td>
                            <td width="15%">
                                <select name="to_wareHouse[]" class="form-control to_wareHouse" id="to_wareHouse" required>
                                    <option value="">Select Warehouse ...</option>
                                    @foreach ($warehouses as $warehouse)
                                        @if (!empty($warehouse->warehouse))
                                            <option value="{{$warehouse->warehouse->id}}" @if ($warehouse->warehouse->id == $warehouse_stock_transfer_item->to_wareHouse) selected="selected" @endif>{{$warehouse->warehouse->name}}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </td>
                            <td width="15%">
                                <textarea name="remarks[]" id="remarks" class="form-control" cols="20"rows="1" placeholder="Remarks">{{ $warehouse_stock_transfer_item->remarks }}</textarea>
                            </td>
                            <td width="5%">
                                <button type="button" @if ($key == 0) disabled @endif class="btn" id="delete_item_button"><i
                                class="fa fa-trash-o icon-trash"></i></button>
                            </td>
                            <td width="5%">
                                <button type="button" class="btn" id="duplicate_item_button"><i
                                        class="fa fa-files-o"></i></button>
                            </td>
                        </tr>
                        @endforeach
                    </tbody>
                </table>
                <div class="form-group">
                    <div class="col-sm-3">
                        <button type="button" class="btn btn-primary mr-1 mb-1" onclick="createStockItemRow()"><i
                                class="feather icon-plus"></i> Add Item
                        </button>
                    </div>
                </div>
            <div class="form-group">
                <div class="col-sm-12">
                    <button class="btn btn-primary pull-right" type="submit">Transfer Stock</button>
                </div>
                <input type="hidden" id="items_rows" name="items_rows" value="1" />
            </div>
        </form>
    </div>
</div>
@endsection

@section('js')
<script>
    $('#create_form').validate(
        {ignore : ":hidden:not(.selectpicker)"  }
    );
    $('.imei_serial_no').select2();
    $('.to_wareHouse').select2();

    $('tbody').delegate('.imei_serial_no', 'change', function () {
        var tr = $(this).parent().parent();
        var imei_serial_no = $(this).val();
        if(imei_serial_no) {
            $.ajax({
                url: '/purchase-invoice/item/'+imei_serial_no,
                type:"GET",
                dataType:"json",
                success:function(data) {
                    console.log("data", data.data);
                    if(data.status == "success") {
                        console.log($(this));
                        tr.find('#item_name').text(data.data.name.name);
                        // tr.find('#color').text(data.data.color);
                        tr.find('#from_warehouse').val(data.data.warehouse_id);
                        tr.find('#item_id').val(data.data.id);
                        tr.find('#f_warehouse').text(data.from_warehouse);
                    }else {
                        alert('failed to retrieve locations for selected IMEI');
                    }

                },
            });
        } else {
            tr.find('#item_name').text('select imei#');
            // tr.find('#color').text('select imei#');
            tr.find('#f_warehouse').text('select imei#');
        }
    });


    function createStockItemRow() {
        $('#item_table').append('<tr>' +
        '<td width="15%"><span id="item_name">select warehouse</span></td>' +
        // '<td width="15%"><span id="color">select warehouse</span></td>' +
        '<td width="15%">' +
            // '<select name="from_wareHouse[]" class="form-control" id="from_wareHouse">' +
            //     '<option value="">Select Warehouse ...</option> @foreach ($warehouses as $warehouse) @if (!empty($warehouse->warehouse)) <option value="{{$warehouse->warehouse->id}}">{{$warehouse->warehouse->name}}</option> @endif @endforeach' +
            // '</select>' +
            '<span id="f_warehouse">select Imei</span>' +
            '<input type="hidden" name="from_warehouse[]" id="from_warehouse" required>' +
            '<input type="hidden" name="item_id[]" class="form-control" id="item_id" value="" required>' +
        '</td>' +
        '<td width="15%">' +
            '<select name="imei_serial_no[]" class="form-control imei_serial_no" id="imei_serial_no">' +
                '<option value="">Select IMEI/Serial #</option>' +
                '@foreach ($items as $item)' +
                '<option value="{{$item->imei_serial_no}}">{{$item->imei_serial_no}}</option>' +
                '@endforeach' +
            '</select>' +
        '</td>' +
        '<td width="15%">' +
            '<select name="to_wareHouse[]" class="form-control" id="to_wareHouse">' +
                '<option value="">Select Warehouse ...</option> @foreach ($warehouses as $warehouse) @if (!empty($warehouse->warehouse)) <option value="{{$warehouse->warehouse->id}}">{{$warehouse->warehouse->name}}</option> @endif @endforeach' +
            '</select>' +
        '</td>' +
        '<td width="15%">' +
            '<textarea name="remarks[]" id="remarks" class="form-control" cols="20"rows="1" placeholder="Remarks"></textarea>' +
        '</td>' +
        '<td width="5%">' +
            '<button type="button" class="btn" id="delete_item_button"><i class="fa fa-trash-o icon-trash"></i></button>' +
        '</td>' +
        '<td width="5%">' +
            '<button type="button" class="btn" id="duplicate_item_button"><i class="fa fa-files-o"></i></button>' +
        '</td></tr>');

        $('#item_table tr:last').find('#imei_serial_no').select2();
        $('#item_table tr:last').find('#to_wareHouse').select2();
    }

    $('#item_table').on('click', 'button[id="delete_item_button"]', function () {
        $(this).closest('tr').remove();
    });

    $('#item_table').on('click', 'button[id="duplicate_item_button"]', function (e) {
        e.preventDefault();
        var $tr = $(this).closest('tr').clone();
        $tr.find('#delete_item_button').prop("disabled", false);
        $tr.find('.select2').remove();
        var imei_serial_no_val = $(this).closest('tr').find('#imei_serial_no').val();
        var to_wareHouse_val = $(this).closest('tr').find('#to_wareHouse').val();
        $('#item_table').append($tr);
        $tr.find('#imei_serial_no').select2();
        $tr.find('#imei_serial_no').val(imei_serial_no_val).trigger('change');
        $tr.find('#to_wareHouse').select2();
        $tr.find('#to_wareHouse').val(to_wareHouse_val).trigger('change');
    });

    $(document).ready(function() {
        // $('.input-group.date').datepicker({
        //     startView: 1,
        //     todayBtn: "linked",
        //     keyboardNavigation: false,
        //     forceParse: false,
        //     autoclose: true,
        //     format: "yyyy-mm-dd"
        // }).datepicker();
    });

</script>


@endsection
